{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 AmezoScape Window Unit                                            }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Amescape2ch;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, ShellApi, HTTPApp, Hzbconst, HttpProt, Main,
  ZonuClass;

type
  TAmezoScape2ch = class(TForm)
    Label1: TLabel;
    KeyWord: TComboBox;
    Label2: TLabel;
    BoardKind: TComboBox;
    Label3: TLabel;
    SortType: TComboBox;
    Image1: TImage;
    DaisenseiUrl: TEdit;
    Label4: TLabel;
    Shape1: TShape;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label5: TLabel;
    HttpCli1: THttpCli;
    procedure FormCreate(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure HttpCli1RequestDone(Sender: TObject; RqType: THttpRequest;
      Error: Word);
  private
    { Private 錾 }
    F2chSite: TSite;
    FHttpStream : TStringStream;
    function Getidxname: string;
    function Getsort: string;
    function NichCgiUrlToDatUrl(const Url: string): string;
  public
    { Public 錾 }
    ThreadItemList: TThreadItemList;
    property  idxname: string read  Getidxname;
    property  sort: string  read  Getsort;
  end;

var
  AmezoScape2ch: TAmezoScape2ch;

implementation

{$R *.DFM}

uses
  ZonuConf, jconvert, MonaUtils, Hzbfunc;

procedure TAmezoScape2ch.FormCreate(Sender: TObject);
begin
  BoardKind.ItemIndex :=  0;
  SortType.ItemIndex  :=  0;
  if  (FileExists(ZonuConfig.UsersPath + FILE_FINDTEXT_LOG))  then  begin
    KeyWord.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_FINDTEXT_LOG);
  end;
  ZonuEnviron.SiteList.FindSite('2ch', F2chSite);
  DaisenseiUrl.Text :=  ZonuConfig.Amesca2chUrl;
  if  (FileExists(ZonuConfig.UsersPath + FILE_FIND_LOG)) then  begin
    KeyWord.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_FIND_LOG);
    if  (KeyWord.Items.Count > 0) then  KeyWord.Text  :=  KeyWord.Items[0];
  end;
end;

function TAmezoScape2ch.Getidxname: string;
begin
  case  BoardKind.ItemIndex  of
    0 : result  :=  '2chpc';
    1 : result  :=  '2chcomic';
    2 : result  :=  '2chanime';
    3 : result  :=  '2chnet';
    4 : result  :=  '2chfood';
    5 : result  :=  '2chlife';
    6 : result  :=  '2chtv';
    7 : result  :=  '2chmusic';
    8 : result  :=  '2chk1';
    9 : result  :=  '2chgame';
   10 : result  :=  '2chcompany';
   11 : result  :=  '2chtech';
   12 : result  :=  '2chunix';
   13 : result  :=  '2chdoujin';
   14 : result  :=  '2chmovie';
   15 : result  :=  '2chcar';
   16 : result  :=  '2chsoccer';
   17 : result  :=  '2chhistory';
   18 : result  :=  '2chwhis';
   19 : result  :=  '2charmy';
  else
    result  :=  '2chpc';
  end;
end;

function TAmezoScape2ch.Getsort: string;
begin
  case  SortType.ItemIndex  of
    0 : result  :=  'score';
    1 : result  :=  'date:late';
    2 : result  :=  'date:early';
    3 : result  :=  'field:subject:ascending';
    4 : result  :=  'field:subject:descending';
    5 : result  :=  'field:size:ascending';
    6 : result  :=  'field:size:descending';
    7 : result  :=  'field:uri:ascending';
    8 : result  :=  'field:uri:descending';
  else
    result  :=  'score';
  end;
end;

procedure TAmezoScape2ch.Image1Click(Sender: TObject);
begin
  Open('http://www.amezoscape.to/');
end;

procedure TAmezoScape2ch.BitBtn1Click(Sender: TObject);
var
  s : string;
begin
  s :=  KeyWord.Text;

  if  (Trim(s) = '')  then  begin
    KeyWord.SetFocus;
    MessageDlg('L[[hĂB', mtError, [mbOk], 0);
    Exit;
  end;
  if  (s <> '') then  begin
    if  (KeyWord.Items.IndexOf(s) < 0) then  begin
      KeyWord.Items.Insert(0, s);
    end else begin
      KeyWord.Items.Move(KeyWord.Items.IndexOf(s), 0);
    end;
    KeyWord.Items.SaveToFile(ZonuConfig.UsersPath + FILE_FIND_LOG);
    
    if  (KeyWord.Items.IndexOf(s) < 0) then  begin
      KeyWord.Items.Insert(0, s);
    end else begin
      KeyWord.Items.Move(KeyWord.Items.IndexOf(s), 0);
    end;
    KeyWord.Items.SaveToFile(ZonuConfig.UsersPath + FILE_FINDTEXT_LOG);
    KeyWord.Text  :=  s;
  end;
  //
  //
  //
  S :=  DaisenseiUrl.Text +
        '?query='   + HTTPEncode(KeyWord.Text) +
        '&submit='  + HTTPEncode('') +
        '&whence=0' +
        '&idxname=' + HTTPEncode(idxname) +
        '&max=100'  +
        //'&result=short' +
        '&result=normal' +
        '&sort='    + HTTPEncode(sort);

  FHttpStream   :=  TStringStream.Create('');
  if  (ZonuConfig.ProxyUse) then  begin
    HttpCli1.Proxy          :=  ZonuConfig.Proxy;
    HttpCli1.ProxyPort      :=  ZonuConfig.ProxyPort;
    HttpCli1.ProxyUsername  :=  ZonuConfig.ProxyUserName;
    HttpCli1.ProxyPassword  :=  ZonuConfig.ProxyPassword;
  end;
  HttpCli1.Agent            :=  USER_AGENT;
  FHttpStream.Position      :=  0;
  FHttpStream.Size          :=  0;
  HttpCli1.RcvdStream       :=  FHttpStream;
  HttpCli1.URL              :=  S;
  HttpCli1.GetASync;
  HotzonuWindow.Memo1.Lines.Add('搶ɖ₢킹ł...');
  HotzonuWindow.Memo1.Lines.Add('By Amezoscape ' + HttpCli1.URL);
  BitBtn1.Enabled   :=  False;
  Screen.Cursor     :=  crHourGlass;
  //ModalResult :=  mrOk;
end;

procedure TAmezoScape2ch.FormShow(Sender: TObject);
begin
  KeyWord.SetFocus;
end;

procedure TAmezoScape2ch.BitBtn2Click(Sender: TObject);
begin
  HttpCli1.Abort;
  Cursor  :=  crDefault;
  ModalResult :=  mrCancel;
end;

procedure TAmezoScape2ch.HttpCli1RequestDone(Sender: TObject;
  RqType: THttpRequest; Error: Word);
var
  Content, S : string;
  n   : integer;
  No : integer;
  ASubject, AUrl, DatUrl : string;
  ThreadItem  : TThreadItem;
  BoardID : string;
  Board : TBoard;
  OldUrl: string;
begin
  HotzonuWindow.Memo1.Lines.Add('搶ԓ');
  if  (HttpCli1.StatusCode = 200) then  begin
    HotzonuWindow.Memo1.Lines.Add('emFEEE');
    Content :=  FHttpStream.DataString;
    S   :=  jconvert.euc2sjis(Content);
    No  :=  0;
    while true  do  begin
      n :=  AnsiPos('<dt>', s);
      if  (n > 0) then  begin
        S :=  Copy(S, n + 4, Length(S));
        //<strong>
        n :=  AnsiPos('>', s);
        S :=  Copy(S, n + 1, Length(S));
        //<a href=>
        n :=  AnsiPos('>', s);
        S :=  Copy(S, n + 1, Length(S));
        //^Cg
        n :=  AnsiPos('</a>', s);
        ASubject  :=  TrimTag(StringReplace(Copy(S, 1, n - 1), '&amp;','&',[rfReplaceAll]));
        //<dd>
        n :=  AnsiPos('<dd><a href="', s);
        S :=  Copy(S, n + 13, Length(S));
        n :=  AnsiPos('">', s);
        AUrl      :=  StringReplace(Copy(S, 1, n - 1), '&amp;','&',[rfReplaceAll]);
        {
        1. <strong><a href="http://piza2.2ch.net/test/read.cgi?bbs=mobile&amp;key=993873237">
        2cĥɍœKȃoCc[</a></strong> (XRA: 13)
        <dd><a href="http://piza2.2ch.net/test/read.cgi?bbs=mobile&amp;key=993873237">
        http://piza2.2ch.net/test/read.cgi?bbs=mobile&amp;key=993873237</a> (157426 bytes)<br><br>
        }
        //
        OldUrl  :=  F2chSite.BBS.ConvUrl(AUrl);
        BoardID :=  ChooseValue(OldUrl, 'bbs');
        DatUrl  :=  NichCgiUrlToDatUrl(OldUrl);
        {
        ThreadItem                    :=  TThreadItem.Create;
        ThreadItem.No                 :=  No + 1;
        ThreadItem.Title              :=  ASubject;
        ThreadItem.DatFileName        :=  ExtractUrlName(DatUrl) + '.dat';
        ThreadItem.RemoteDatFilePath  :=  DatUrl;
        ThreadItem.LocalDatFilePath   :=  ZonuEnvironment.CachePath + UrlToFileName(DatUrl);
        n :=  AnsiPos('dat/', DatUrl);
        ThreadItem.BoardUrl           :=  Copy(DatUrl, 1, n - 1);
        ThreadItem.CreateFromFavorite :=  True;
        ThreadItem.BBSType            :=  btNich;
        ThreadItem.DatExists          :=  FileExists(ThreadItem.LocalDatFilePath);
        ThreadItem.LoadConfig;
        ThreadItem.AgeCount           :=  ThreadItem.ReadCount;
        GetBoardName(ThreadItem);
        }
        if  (F2chSite.BoardList.FindBoard(BoardID, Board))  then  begin
          ThreadItem  :=  TThreadItem.Create;
          ThreadItem.CreateThreadItem(Board.Site.SiteID,
                                      Board.BoardID,
                                      ChooseValue(OldUrl, 'key'),
                                      ASubject);
          if  (ThreadItem.Board <> nil) then  begin
            inc(No);
            ThreadItem.LoadConfig;
            ThreadItem.No     :=  No;
            ThreadItemList.Add(ThreadItem);
            (*
            *!*
            ThreadItem        :=  TThreadItem.Create;
            //ThreadItem.Board  :=  Board;
            ThreadItem.BoardID  :=  Board.BoardID;
            ThreadItem.BBS    :=  Board.BBS;
            ThreadItem.Site   :=  Board.Site;
            ThreadItem.DatFileName        :=  ChooseValue(OldUrl, 'key') +  '.dat'; //ExtractUrlName(DatUrl) + '.dat';
            ThreadItem.LocalDatFileName   :=  Board.CachePath + ThreadItem.DatFileName;
            if  (ThreadItem.BBS.ThreadDownlaodMode = dmText)  then  begin
              ThreadItem.RemoteDatFileName  :=  ThreadItem.BBS.GetDatUrl(Board, ThreadItem.DatFileName);
            end else begin
              ThreadItem.RemoteDatFileName  :=  ThreadItem.BBS.GetReadCgiUrl(ThreadItem);
            end;
            ThreadItem.LoadConfig;
            ThreadItem.No     :=  No;
            ThreadItem.Title  :=  ASubject;
            ThreadItemList.Add(ThreadItem);
            *)
          end;
        end;
        //x :=  NewListBox.Items.Add(IntToStr(ThreadItem.No));
        //NewListBox.Items.Objects[x] :=  ThreadItem;
      end else begin
        Break;
      end;
    end;
  end else begin
    MessageDlg(IntToStr(HttpCli1.StatusCode) + #13#10 + HttpCli1.ReasonPhrase, mtError, [mbOk], 0);
  end;
  Screen.Cursor :=  crDefault;
  ModalResult   :=  mrOk;
end;

function TAmezoScape2ch.NichCgiUrlToDatUrl(const Url: string): string;
var
  S, BBS , Key, AUrl : string;
begin

  AUrl  :=  F2chSite.BBS.ConvUrl(Url);  //NichReadCgiUrlNewToOld();
  {http://teri.2ch.net/test/read.cgi?bbs=accuse&key=991408877&ls=50}
  {http://teri.2ch.net/accuse/dat/991408877.dat}
  S       :=  MonaUtils.ExtractHostName(AUrl);
  BBS     :=  ChooseValue(AUrl, 'bbs');
  Key     :=  ChooseValue(AUrl, 'key');
  Result  :=  'http://' + S + '/' + BBS + '/dat/' + Key + '.dat';
end;


end.
