{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 BoardList Editor Unit                                             }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Bbsedt;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Dlghead, ComCtrls, EnhListView, ExtListView, StdCtrls, ExtCtrls,
  ZonuClass;

type
  THoge = class(TObject)
  private
    FCategoryName: string;
    FList: TList;
  public
    constructor Create;
    destructor Destroy; override;
    property  CategoryName: string  read  FCategoryName write FCategoryName;
    property  BoardList: TList  read  FList write FList;
  end;

  //TABCList: TList; 

  TBBSEditor = class(TForm)
    HeaderFrame1: THeaderFrame;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    ListBox1: TListBox;
    Panel3: TPanel;
    ListView1: TdfsExtListView;
    procedure ListBox1Click(Sender: TObject);
    procedure ListView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ListView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ListView1StartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    FSite : TSite;
    FHogeList: TList;
    FListViewDragging: boolean;
    FListViewX, FListViewY: integer;
  public
    { Public 錾 }
    procedure Open(Site: TSite);
  end;

var
  BBSEditor: TBBSEditor;

implementation

{$R *.dfm}

uses
  Hzbconst, ZonuConf;

const
  NO_CATEGORY = '<JeS>';

{ THoge }

constructor THoge.Create;
begin
  FList :=  TList.Create;
end;

destructor THoge.Destroy;
begin
  FList.Free;
  inherited;
end;

{ TBBSEditor }

procedure TBBSEditor.FormCreate(Sender: TObject);
begin
  FHogeList :=  TList.Create;
end;

procedure TBBSEditor.FormDestroy(Sender: TObject);
begin
  FHogeList.Clear;
  FHogeList.Free;
end;

procedure TBBSEditor.Open(Site: TSite);
var
  FHoge: THoge;
  CategoryName: string;
  i : integer;
  sl: TStringList;
begin
  FSite :=  Site;
  sl    :=  TStringList.Create;
  CategoryName  :=  '{9FACD720-E48B-11D6-9163-0040267EBC39}';
  for i :=  0 to  Site.BoardList.Count - 1  do  begin
    if  (CategoryName <> Site.BoardList[i].CategoryName)  then  begin
      CategoryName  :=  Site.BoardList[i].CategoryName;
      FHoge :=  THoge.Create;
      FHoge.CategoryName  :=  CategoryName;
      ListBox1.Items.Objects[ListBox1.Items.Add(CategoryName)]  :=  FHoge;
    end else begin

    end;
  end;
  //
  sl.Free;
end;

procedure TBBSEditor.ListBox1Click(Sender: TObject);
var
  Item: TListItem;
  s: string;
  i: integer;
begin
  ListView1.Items.Clear;
  if  (ListBox1.Items[ListBox1.ItemIndex] = NO_CATEGORY)  then  begin
    s :=  '';
  end else begin
    s :=  ListBox1.Items[ListBox1.ItemIndex];
  end;
  for i :=  0 to  FSite.BoardList.Count - 1 do  begin
    if  (FSite.BoardList[i].CategoryName = s) then  begin
      Item  :=  ListView1.Items.Add;
      Item.Caption  :=  FSite.BoardList[i].Name;
      Item.SubItems.Add(FSite.BoardList[i].RemoteBoardID);
      Item.SubItems.Add(FSite.BoardList[i].BoardID);
      Item.SubItems.Add(FSite.BoardList[i].Url);
      Item.SubItems.Add(FSite.BoardList[i].CachePath);
      Item.Data :=  FSite.BoardList[i];
    end;
  end;
end;

procedure TBBSEditor.ListView1StartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
  FListViewDragging  :=  True;
  FListViewX  :=  0;
  FListViewY  :=  0;
end;

procedure TBBSEditor.ListView1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept  :=  (Source = ListView1);
  FListViewX  :=  X;
  FListViewY  :=  Y;
end;

procedure TBBSEditor.ListView1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  DropItem  : TListItem;
  List  : TList;
  Index : integer;
  i, z : integer;
begin
  DropItem  :=  ListView1.GetItemAt(X, Y);
  if  (DropItem <> nil) then  begin
    Index   :=  DropItem.Index;
  end else
  if  (Y  > 0)  then  begin
    Index   :=  ListView1.Items.Count;
  end else begin
    Index   :=  -1;
  end;
  List  :=  TList.Create;
  for i :=  ListView1.Items.Count - 1 downto  0 do  begin
    if  (ListView1.Items[i].Selected)  then  begin
      //FSite.BoardList.Move(ListView1.Items[i].);
    end;
  end;
  {
  for i :=  FThreadItemList.Count - 1 downto  0 do  begin
    if  (ListView1.Items[i].Selected) then  begin
      List.Add(FThreadItemList[i]);
      FThreadItemList.Erase(i);
      if (i < Index) then Dec(Index);
      ListView1.Items[i].Selected :=  False;
    end;
  end;
  ListView1.Selected  :=  nil;
  for i :=  0 to  List.Count  - 1 do  begin
    FThreadItemList.Insert(Index, List[i]);
  end;
  for i :=  0 to  FThreadItemList.Count  - 1 do  begin
    for z :=  0 to  List.Count - 1  do  begin
      if (FThreadItemList[i] = List[z]) then  begin
        ListView1.Items[i].Selected :=  True;
        Break;
      end;
    end;
  end;
  }
  List.Free;
end;

end.
