unit Bbssetup;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, Buttons, HttpProt, IniFiles;

type
  TBBSSetupDialog = class(TForm)
    PageControl1: TPageControl;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Bevel1: TBevel;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Label4: TLabel;
    ProgressBar1: TProgressBar;
    Animate1: TAnimate;
    Label5: TLabel;
    Memo1: TMemo;
    HttpCli1: THttpCli;
    Label6: TLabel;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
    FSiteID: string;
  public
    { Public 錾 }
    property  SiteID: string  read  FSiteID;
  end;

var
  BBSSetupDialog: TBBSSetupDialog;

implementation

{$R *.dfm}

uses
  ZonuClass, ZonuConf, Hzbconst, MonaUtils;

const
  DOWNLOADFILES : array [0..5] of string =
    ('back.bmp','board.dat','comment.txt', 'icon.bmp', 'ParseBoard.giko', 'site.ini');

procedure TBBSSetupDialog.FormCreate(Sender: TObject);
begin
  PageControl1.ActivePage :=  TabSheet1;
end;

procedure TBBSSetupDialog.Button2Click(Sender: TObject);
var
  i: integer;
  Site: TSite;
  ini: TMemIniFile;
  FHttpStream : TMemoryStream;
  FHTTPCli: THTTPCli;
begin
  if  (PageControl1.ActivePage = TabSheet1) then  begin
    PageControl1.ActivePage := TabSheet2;
    Edit1.SetFocus;
  end else
  if  (PageControl1.ActivePage = TabSheet2) then  begin
    FSiteID :=  ExtractUrlName(ExcludeTrailingSlash(Edit1.Text));
    if  (FSiteID = '') then  begin
      Edit1.SetFocus;
    end else
    if  (ZonuEnviron.SiteList.FindSite(FSiteID, Site)) then  begin
      MessageDlg('łɓo^ĂBBSłB'  + #13#10 +
                  Site.SiteName + '(' + Site.SiteID + ')',
                  mtError, [mbOk], 0);
      Edit1.SetFocus;
    end else begin
      Edit1.Text  :=  IncludeTrailingSlash(Edit1.Text);
      ForceDirectories(ZonuConfig.AppPath + PATH_SITE_CONFIG + FSiteID);
      PageControl1.ActivePage := TabSheet3;
      Animate1.Active :=  True;
      Update;
      //
      Screen.Cursor :=  crHourGlass;
      ProgressBar1.Min  :=  Low(DOWNLOADFILES);
      ProgressBar1.Max  :=  High(DOWNLOADFILES) + 1;
      ProgressBar1.Position :=  ProgressBar1.Min;
      ProgressBar1.Step     :=  1;
      for i :=  Low(DOWNLOADFILES) to High(DOWNLOADFILES) do  begin
        FHttpCli      :=  THTTPCli.Create(Self);
        FHttpStream   :=  TMemoryStream.Create;
        if  (ZonuConfig.ProxyUse) then  begin
          FHttpCli.Proxy          :=  ZonuConfig.Proxy;
          FHttpCli.ProxyPort      :=  ZonuConfig.ProxyPort;
          FHttpCli.ProxyUsername  :=  ZonuConfig.ProxyUserName;
          FHttpCli.ProxyPassword  :=  ZonuConfig.ProxyPassword;
        end;
        FHttpCli.Agent            :=  USER_AGENT;
        FHttpStream.Position      :=  0;
        FHttpStream.Size          :=  0;
        FHttpCli.RcvdStream       :=  FHttpStream;

        Label6.Caption            :=  DOWNLOADFILES[i];
        FHttpCli.URL              :=  Edit1.Text + DOWNLOADFILES[i];
        try
          try
            while (FHttpCli.State <> httpReady)  do  begin
              Sleep(1000);
            end;
            FHttpCli.Get;
            if  (FHttpCli.StatusCode = 200) then  begin
              FHttpStream.SaveToFile(ZonuConfig.AppPath + PATH_SITE_CONFIG + FSiteID + '\' + DOWNLOADFILES[i]);
              FHttpStream.Clear;
            end;
          except
            on E: EHttpException  do
               begin
                FHttpCli.Abort;
                FHttpCli.CtrlSocket.Close;
                Continue;
               end;
          end;
        finally
          ProgressBar1.StepIt;
          FHttpStream.Free;
          FHttpCli.Free;
        end;
      end;
      //
      //
      ini :=  TMemIniFile.Create(ZonuConfig.AppPath + PATH_SITE_CONFIG + FSiteID + '\' + INI_SITE);
      Memo1.Lines.Add(ini.ReadString('SITE', 'NAME', ''));
      Memo1.Lines.Add(ini.ReadString('SITE', 'URL', ''));
      Memo1.Lines.Add('--');
      Memo1.Lines.Add('SCRIPT:' + ini.ReadString('SITE', 'BBSTYPE', ''));
      Memo1.Lines.Add('CHAR  :' + ini.ReadString('SITE', 'CHARSET', ''));
      Memo1.Lines.Add('ADMIN :' + ini.ReadString('SITE', 'ADMIN', ''));
      ini.Free;
      //
      
      //
      Screen.Cursor :=  crDefault;
      PageControl1.ActivePage := TabSheet4;
      Button1.Enabled :=  False;
      Button2.Caption :=  '';
    end;
  //end else
  //if  (PageControl1.ActivePage = TabSheet4) then  begin
    //PageControl1.ActivePage := TabSheet4;
  end else
  if  (PageControl1.ActivePage = TabSheet4) then  begin
    ModalResult :=  mrOk;
  end;
end;

procedure TBBSSetupDialog.Button1Click(Sender: TObject);
begin
  if  (PageControl1.ActivePageIndex > 0)  then
    PageControl1.ActivePageIndex := PageControl1.ActivePageIndex - 1;
end;

procedure TBBSSetupDialog.Button3Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

end.
