{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 PopupMenu Customize Dialog Unit                                   }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Custommn;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ActnList, ComCtrls, StdCtrls, Buttons, ExtCtrls, Main,
  IniFiles, Dlghead;

type
  TCustomPopupMenuDialog = class(TForm)
    Button1: TButton;
    Button2: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    SpeedButton1: TSpeedButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ListView1: TListView;
    ListView2: TListView;
    Button3: TButton;
    Button4: TButton;
    Button6: TButton;
    Button5: TButton;
    ActionList1: TActionList;
    actAdd: TAction;
    actDelete: TAction;
    actAddSeparator: TAction;
    actMoveUp: TAction;
    actMoveDown: TAction;
    PopupMenu1: TPopupMenu;
    A1: TMenuItem;
    PopupMenu2: TPopupMenu;
    S1: TMenuItem;
    N1: TMenuItem;
    U1: TMenuItem;
    D1: TMenuItem;
    N2: TMenuItem;
    S2: TMenuItem;
    HeaderFrame1: THeaderFrame;
    Button7: TButton;
    Button8: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure actAddExecute(Sender: TObject);
    procedure actDeleteExecute(Sender: TObject);
    procedure actAddSeparatorExecute(Sender: TObject);
    procedure actMoveUpExecute(Sender: TObject);
    procedure actMoveDownExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private 錾 }
    procedure RefreshPopupMenus(const RefreshActions: boolean);
  public
    { Public 錾 }
  end;

  TZonuPopupMenuList = class(TStringList)
  private
    FPopupMenu: TPopupMenu;
  public
    property  PopupMenu: TPopupMenu   read  FPopupMenu  write FPopupMenu;
  end;

var
  CustomPopupMenuDialog: TCustomPopupMenuDialog;

implementation

{$R *.dfm}

uses
  HzbClass, Hzbfunc, ZonuConf, ZonuClass, Hzbconst;

procedure TCustomPopupMenuDialog.FormCreate(Sender: TObject);
  procedure AddComboBox(PopupMenu: TPopupMenu; ACaption: string);
  var
    i, x : integer;
    StringList : TZonuPopupMenuList;
  begin
    x :=  ComboBox2.Items.Add(ACaption);
    StringList := TZonuPopupMenuList.Create;
    for i :=  0 to  PopupMenu.Items.Count - 1 do  begin
      if  (PopupMenu.Items[i].Caption = '-')  then  begin
        StringList.Add('-');
      end else begin
        if  (PopupMenu.Items[i].Action <> nil)  then  begin
          StringList.Add(PopupMenu.Items[i].Action.Name);
        end;
      end;
    end;
    StringList.PopupMenu  :=  PopupMenu;
    ComboBox2.Items.Objects[x] := StringList;
  end;
var
  i : integer;
  s : string;
begin
  AddComboBox(HotzonuWindow.BoardListPopup,   '{[hꗗ|bvAbvj[');
  AddComboBox(HotzonuWindow.ThreadListPopup,  'Xbhꗗ|bvAbvj[');
  AddComboBox(HotzonuWindow.ThreadItemPopup,  'Xbhꗗ(XbhI)|bvAbvj[');
  AddComboBox(HotzonuWindow.BrowserPopup,     'uEU|bvAbvj[');
  AddComboBox(HotzonuWindow.ResPopup,         'uEU(XI)|bvAbvj[');
  s := '';
  for i :=  0 to  HotzonuWindow.ActionList1.ActionCount - 1 do  begin
    if  (s <> HotzonuWindow.ActionList1.Actions[i].Category)  then  begin
      s :=  HotzonuWindow.ActionList1.Actions[i].Category;
      if  (ComboBox1.Items.IndexOf(s) < 0)  then  begin
        if  (s <> '') then  begin
          ComboBox1.Items.Add(s);
        end;
      end;
    end;
  end;
  ComboBox2.ItemIndex :=  0;
  ComboBox2.OnChange(ComboBox2);
  ComboBox1.ItemIndex :=  0;
  ComboBox1.OnChange(ComboBox1);
end;

procedure TCustomPopupMenuDialog.ComboBox1Change(Sender: TObject);
var
  Item : TListItem;
  i : integer;
begin
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  for i :=  0 to  HotzonuWindow.ActionList1.ActionCount - 1 do  begin
    if  (HotzonuWindow.ActionList1.Actions[i].Category = ComboBox1.Text)  then  begin
      if  (TStringList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]).IndexOf(TAction(HotzonuWindow.ActionList1.Actions[i]).Name) < 0) then
      begin
        Item  :=  ListView1.Items.Add;
        Item.Caption    :=  '[' + HotzonuWindow.ActionList1.Actions[i].Category + ']' + 
                            TAction(HotzonuWindow.ActionList1.Actions[i]).Caption;
        Item.ImageIndex :=  TAction(HotzonuWindow.ActionList1.Actions[i]).ImageIndex;
        Item.Data       :=  HotzonuWindow.ActionList1.Actions[i];
      end;
    end;
  end;
  ListView1.Items.EndUpdate;
end;

procedure TCustomPopupMenuDialog.ComboBox2Change(Sender: TObject);
begin
  RefreshPopupMenus(True);
end;

procedure TCustomPopupMenuDialog.RefreshPopupMenus(const RefreshActions: boolean);
var
  Action  : TAction;
  Item : TListItem;
  sl : TStringList;
  i : integer;
begin
  sl  :=  TStringList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
  ListView2.Items.BeginUpdate;
  ListView2.Items.Clear;
  for i :=  0 to  sl.Count - 1  do  begin
    if  (sl[i] = '-') then  begin
      Item    :=  ListView2.Items.Add;
      Item.Caption    :=  '-';
      Item.ImageIndex :=  -1;
      Item.Data       :=  nil;
    end else begin
      Action  :=  FindAction(sl[i]);
      Item    :=  ListView2.Items.Add;
      Item.Caption    :=  '[' + Action.Category + ']' + Action.Caption;
      Item.ImageIndex :=  Action.ImageIndex;
      Item.Data       :=  Action;
    end;
  end;
  if  (Showing) and (RefreshActions) then  begin
    ComboBox1.OnChange(ComboBox1);
  end;
  ListView2.Items.EndUpdate;
end;

procedure TCustomPopupMenuDialog.Button2Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

procedure TCustomPopupMenuDialog.Button1Click(Sender: TObject);
var
  ini : TMemIniFile;
  i, x : integer;
  sl: TZonuPopupMenuList;
  PopupMenu: TPopupMenu;
begin
  ini :=  TMemIniFile.Create(ZonuConfig.UsersPath + FILE_POPUPMENU_INI);
  for i :=  0 to  ComboBox2.Items.Count - 1 do  begin
    sl  :=  TZonuPopupMenuList(ComboBox2.Items.Objects[i]);
    PopupMenu :=  sl.PopupMenu;
    ini.EraseSection(PopupMenu.Name);
    ini.WriteInteger(PopupMenu.Name, 'COUNT', sl.Count);
    for x :=  0 to  sl.Count - 1  do  begin
      ini.WriteString(PopupMenu.Name, 'ITEM' + IntToStr(x + 1), sl[x]);
    end;
  end;
  ini.UpdateFile;
  ini.Free;
  ModalResult :=  mrOk;
end;

procedure TCustomPopupMenuDialog.actAddExecute(Sender: TObject);
var
  sl : TStringList;
  a : TAction;
  i : integer;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    if  (ListView1.Items[i].Selected) then  begin
      a   :=  TAction(ListView1.Items[i].Data);
      sl  :=  TStringList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
      sl.Add(a.Name);
    end;
  end;
  ComboBox2.OnChange(ComboBox2);
end;

procedure TCustomPopupMenuDialog.actDeleteExecute(Sender: TObject);
var
  sl : TStringList;
  i : integer;
begin
  sl  :=  TStringList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
  for i :=  ListView2.Items.Count - 1 downto  0 do  begin
    if  (ListView2.Items[i].Selected) then  begin
      sl.Delete(i);
    end;
  end;
  ComboBox2.OnChange(ComboBox2);
end;

procedure TCustomPopupMenuDialog.actAddSeparatorExecute(Sender: TObject);
var
  sl : TStringList;
  Item : TListItem;
begin
  sl  :=  TStringList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
  sl.Add('-');
  Item    :=  ListView2.Items.Add;
  Item.Caption    :=  '<؂>';
  Item.ImageIndex :=  -1;
  Item.Data       :=  nil;
end;

procedure TCustomPopupMenuDialog.actMoveUpExecute(Sender: TObject);
var
  i, n : integer;
  sl : TStringList;
begin
  n   :=  -1;
  sl  :=  TStringList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
  for i :=  1 to  ListView2.Items.Count - 1 do  begin
    if  (ListView2.Items[i].Selected) then  begin
      sl.Move(i, i - 1);
      if  (n < 0) then  n :=  i - 1;
    end;
  end;
  RefreshPopupMenus(False);
  if  (n > -1)  then  ListView2.Selected  :=  ListView2.Items[n];
end;

procedure TCustomPopupMenuDialog.actMoveDownExecute(Sender: TObject);
var
  i, n : integer;
  sl : TStringList;
begin
  n   :=  -1;
  sl  :=  TStringList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
  for i :=  ListView2.Items.Count - 2 downto  0 do  begin
    if  (ListView2.Items[i].Selected) then  begin
      sl.Move(i, i + 1);
      if  (n < 0) then  n :=  i + 1;
    end;
  end;
  RefreshPopupMenus(False);
  if  (n > -1)  then  ListView2.Selected  :=  ListView2.Items[n];
end;

procedure TCustomPopupMenuDialog.FormDestroy(Sender: TObject);
var
  i : integer;
begin
  for i :=  ComboBox2.Items.Count - 1 downto  0 do  begin
    if  (ComboBox2.Items.Objects[i] <> nil) then  begin
      TStringList(ComboBox2.Items.Objects[i]).Free;
    end;
  end;
end;

procedure TCustomPopupMenuDialog.Button7Click(Sender: TObject);
var
  i, x:  integer;
  sl: TZonuPopupMenuList;
  ini: TMemIniFile;
begin
  if  (Sender = Button7)  then  begin
    ini :=  TMemIniFile.Create(ZonuConfig.AppPath + PATH_DEF + 'popup_simple.ini');
  end else begin
    ini :=  TMemIniFile.Create(ZonuConfig.AppPath + PATH_DEF + 'popup_full.ini');
  end;
  for i :=  0 to  ComboBox2.Items.Count - 1 do  begin
    sl  :=  TZonuPopupMenuList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
    sl.Clear;
    for x :=  0 to  ini.ReadInteger(sl.PopupMenu.Name, 'COUNT', 0) - 1 do  begin
      sl.Add(ini.ReadString(sl.PopupMenu.Name, 'ITEM' + IntToStr(x + 1), ''));
    end;
  end;
  ini.Free;
  RefreshPopupMenus(True);
end;

end.
