{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Extract Links Dialog Unit                                         }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Extrlnk;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, EnhListView, ExtListView, StdCtrls, OleCtrls,
  SHDocVw, ZonuClass, HzbClass, Clipbrd, Menus, Dlghead, EmbeddedWB;

type
  TLinkItem = class(TObject)
  private
    FFileExt: string;
    FUrl: string;
    FFileName: string;
    FRes: TRes;
    FResList: TResList;
    //FIsBookmarked: boolean;
  public
    property  ResList: TResList   read  FResList  write FResList;
    property  Res: TRes   read  FRes  write FRes;
    property  Url: string read  FUrl  write FUrl;
    property  FileName: string  read  FFileName write FFileName;
    property  FileExt: string read  FFileExt  write FFileExt;
    //property  IsBookmarked: boolean read  FIsBookmarked write FIsBookmarked;
  end;

  TExtractLinkDialog = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel6: TPanel;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Label2: TLabel;
    Edit1: TEdit;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Button3: TButton;
    Button4: TButton;
    PopupMenu1: TPopupMenu;
    A1: TMenuItem;
    C1: TMenuItem;
    Button5: TButton;
    HeaderFrame1: THeaderFrame;
    N1: TMenuItem;
    URLC1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel2: TPanel;
    Splitter2: TSplitter;
    Panel3: TPanel;
    ListView1: TdfsExtListView;
    BrowserPanel: TPanel;
    Panel5: TPanel;
    ComboBox2: TComboBox;
    Button1: TButton;
    Button2: TButton;
    WebBrowser2: TEmbeddedWB;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure A1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBox2Click(Sender: TObject);
    procedure URLC1Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
  private
    { Private 錾 }
    FBrowser : TZonuBrowser;
    FList: TList;
    FLinkList: TList;
    //FSaveResList : TResList;
    procedure ShowList;
    procedure Preview(LinkItem: TLinkItem);
  public
    { Public 錾 }
    //procedure AddResList(ResList: TResList);
    procedure AddThreadItem(AThreadItem: TThreadItem); overload;
    procedure AddThreadItem(AThreadItem: TThreadItem; AResList: TResList); overload;
    procedure Extract;
  end;

var
  ExtractLinkDialog: TExtractLinkDialog;

implementation

{$R *.dfm}

uses
  MonaUtils, Zonutils, ZonuConf, Hzbconst, ShellApi, Expdlg, Hzbfunc;

type
  TDownloader = class
  public
    Title: string;
    Path: string;
  end;

procedure TExtractLinkDialog.FormCreate(Sender: TObject);
var
  sl  : TStringList;
  dl  : TDownloader;
  i: integer;
begin
  FList     :=  TList.Create;
  FLinkList :=  TList.Create;
  if  (not FileExists(ZonuConfig.UsersPath + FILE_LINKEXT)) then  begin
    CopyFile(PChar(ZonuConfig.AppPath + PATH_DEF + FILE_LINKEXT),
             PChar(ZonuConfig.UsersPath + FILE_LINKEXT),
             True);
  end;
  //CheckListBox1.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_LINKEXT);

  if  (not FileExists(ZonuConfig.UsersPath + FILE_LINKTYPE)) then  begin
    CopyFile(PChar(ZonuConfig.AppPath + PATH_DEF + FILE_LINKTYPE),
             PChar(ZonuConfig.UsersPath + FILE_LINKTYPE),
             True);
  end;
  ComboBox1.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_LINKTYPE);
  if  (ComboBox1.Items.Count > 0) then  ComboBox1.ItemIndex :=  0;
  //
  ComboBox2.Items.Clear;

  dl  :=  TDownloader.Create;
  dl.Title  :=  'Nbv{[h';
  dl.Path   :=  'clipboard';
  ComboBox2.Items.Objects[ComboBox2.Items.Add(dl.Title)] := dl;
  {
  dl  :=  TDownloader.Create;
  dl.Title  :=  'Oۑ';
  dl.Path   :=  'exportlog';
  ComboBox2.Items.Objects[ComboBox2.Items.Add(dl.Title)] := dl;
  }
  //
  sl  :=  TStringList.Create;
  if  (FileExists(ZonuConfig.UsersPath + FILE_DOWNLOADER))  then  begin
    sl.LoadFromFile(ZonuConfig.UsersPath + FILE_DOWNLOADER);
  end;
  for i :=  0 to  sl.Count - 1  do  begin
    dl  :=  TDownloader.Create;
    dl.Title  :=  sl.Names[i];
    dl.Path   :=  ChooseString(sl[i], '=', 1);
    ComboBox2.Items.Objects[ComboBox2.Items.Add(dl.Title)] := dl;
  end;
  sl.Free;
  if  (ComboBox2.Items.Count > 0) then  ComboBox2.ItemIndex :=  0;
end;

procedure TExtractLinkDialog.FormDestroy(Sender: TObject);
var
  i : integer;
begin
  for i :=  FList.Count - 1 downto  0 do  begin
    TResList(FList[i]).Free;
  end;
  FList.Free;
  for i :=  FLinkList.Count - 1 downto  0 do  begin
    TLinkItem(FLinkList[i]).Free;
  end;
  for i :=  ComboBox2.Items.Count - 1 downto  0 do  begin
    TDownloader(ComboBox2.Items.Objects[i]).Free;
  end;
  FLinkList.Free;
  FBrowser.ThreadItem :=  nil;
  FBrowser.ResList    :=  nil;
  FBrowser.Free;
end;

{
procedure TExtractLinkDialog.AddResList(ResList: TResList);
begin
  FSaveResList  :=  ResList;
  FList.Add(ResList);
end;
}

procedure TExtractLinkDialog.AddThreadItem(AThreadItem: TThreadItem);
var
  AResList: TResList;
begin
  AResList    :=    TResList.Create(AThreadItem);
  AThreadItem.LoadFromFile(AResList);
  FList.Add(AResList);
end;

procedure TExtractLinkDialog.Extract;
const
  NORMAL_CHAR: string = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789:/.%?&#=-_~+*;!^`\|@[]{}$,';
var
  LinkItem  : TLinkItem;
  s : string;
  url: string;
  FileName: string;
  FileExt: string;
  i, x, y, z: Integer;
  idx, idx1, idx2, idx3: Integer;
  ResList : TResList;
  Res : TRes;
  prefix: string;
  b : boolean;
begin
  for x :=  0 to  FList.Count - 1 do  begin
    ResList :=  TResList(FList[x]);
    for y :=  0 to  ResList.Count - 1  do  begin
      Res :=  ResList[y];
      s :=  TrimTag(StringReplace(Res.Body, '<BR>', #13#10, [rfReplaceAll, rfIgnoreCase]));
      while True do begin
        idx1 := AnsiPos('http://', s);
        idx2 := AnsiPos('ttp://', s);

        if (idx1 = 0) and (idx2 = 0) then begin
          //N[B
          //Result := Result + s;
          Break;
        end;

        if  (idx2 < idx1) or ((idx2 > 0) and (idx1 = 0)) then  begin
          // ttp
          idx  :=  idx2;
          prefix:=  'h';
        end else begin
          idx  :=  idx1;
          prefix:=  '';
        end;

        //Result := Result + Copy(s, 0, idx - 1);
        s := Copy(s, idx, length(s));
        for i := 0 to Length(s) - 1 do begin
          idx3 := AnsiPos(s[i + 1], NORMAL_CHAR);
          if (idx3 = 0) or (i = (Length(s) - 1)) then begin
            //URLȂIƂAȂȂB
            if  (i = (Length(s) - 1)) then  begin
              url := prefix + Copy(s, 1, i + 1);
            end else begin
              url := prefix + Copy(s, 1, i);
            end;
            FileName  :=  ExtractUrlName(Url);
            FileExt   :=  AnsiLowerCase(ExtractFileExt(FileName));
            if  (AnsiPos('?', FileExt) > 0) then  begin
              FileExt :=  Copy(FileExt, 1, AnsiPos('?', FileExt) - 1);
            end;
            //if  (FileExt <> '') then  begin
            b :=  False;
            for z :=  0 to  FLinkList.Count - 1 do  begin
              if  (TLinkItem(FLinkList[z]).Url = Url) then  begin
                b :=  True;
                Break;
              end;
            end;
            if  (not b) then  begin
              LinkItem  :=  TLinkItem.Create;
              LinkItem.ResList    :=  ResList;
              LinkItem.Res        :=  Res;
              LinkItem.Url        :=  Url;
              LinkItem.FileName   :=  FileName;
              LinkItem.FileExt    :=  FileExt;
              FLinkList.Add(LinkItem);
            end;
            //end;
            s := Copy(s, i + 1, Length(s));
            Break;
          end;
        end;
      end;
    end;
  end;
end;

procedure TExtractLinkDialog.ShowList;
var
  i, x : integer;
  Item  : TListItem;
  LinkItem : TLinkItem;
  b : boolean;
begin
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  for i :=  0 to  FLinkList.Count - 1 do  begin
    LinkItem  :=  TLinkItem(FLinkList[i]);
    if  (CheckBox1.Checked) then  begin
      if  (not LinkItem.Res.IsNew)  then  begin
        Continue;
      end;
    end;
    if  (CheckBox2.Checked) then  begin
      if  (LinkItem.ResList.ThreadItem.BookmarkList.FindRes(LinkItem.Res.No) = nil) then  begin
        Continue;
      end;
    end;
    if  (CheckBox3.Checked) then  begin
      b :=  False;
      for x :=  0 to  ZonuEnviron.SiteList.Count - 1 do  begin
        if  (ZonuEnviron.SiteList[x].IsInclude(LinkItem.Url))  then  begin
          b :=  True;
          Break;
        end;
      end;
      if  (not b) then  Continue;
    end;
    Item  :=  ListView1.Items.Add;
    Item.Caption  :=  Format('%.4d', [LinkItem.Res.No]);
    Item.SubItems.Add(TrimTag(LinkItem.Res.Name));
    Item.SubItems.Add(LinkItem.Url);
    Item.SubItems.Add(LinkItem.FileName);
    Item.SubItems.Add(LinkItem.FileExt);
    Item.SubItems.Add(LinkItem.ResList.ThreadItem.Title);
    Item.Data :=  LinkItem;
  end;
  if  (FList.Count > 1) then  begin
    ListView1.LastColumnClicked :=  5;  //XbhŃ\[g
  end else begin
    ListView1.LastColumnClicked :=  0;
  end;
  ListView1.Resort;
  ListView1.Items.EndUpdate;
end;

procedure TExtractLinkDialog.Preview(LinkItem: TLinkItem);
  function  _IsRefNGRes(S, r: string): boolean;
  var
    n : integer;
    x : string;
  begin
    Result  :=  False;
    n :=  AnsiPos(S, r);
    if  (n < 1) then  Exit;
    x :=  Copy(r, n + Length(S), 1);
    if  (not IsNumeric(x))  then  begin
      Result  :=  True;
    end;
  end;
var
  doc : variant;
  i : integer;
  ResList: TResList;
begin
  //FBrowser.ThreadItem.Assign(LinkItem.ResList.ThreadItem);
  //FBrowser.Board        :=  LinkItem.ResList.ThreadItem.Board;
  {
  if  (FBrowser.ThreadItem <> nil)  then  begin
    FBrowser.ThreadItem.ReleaseRef;
  end;
  }
  FBrowser.BoardID        :=  LinkItem.ResList.ThreadItem.BoardID;
  FBrowser.ThreadItem     :=  LinkItem.ResList.ThreadItem;
  //LinkItem.ResList.ThreadItem.AddRef;
  ResList :=  FBrowser.ResList;
  if  (ResList = nil) then  begin
    ResList :=  TResList.Create(nil);
    FBrowser.ResList  :=  ResList;
  end;
  //FBrowser.ResList        :=  LinkItem.ResList;
  FBrowser.ResList.ThreadItem :=  LinkItem.ResList.ThreadItem;
  if  (not  Assigned(FBrowser.Document))  then  begin
    FBrowser.Navigate('about:blank');
    while (not Assigned(FBrowser.Document)) do  begin
      Application.ProcessMessages;
      if  (ZonuEnviron.Disconnected)  then  begin
        raise EZonuError.Create('ؒf܂B');
      end;
    end;
  end;
  doc :=  FBrowser.Document;
  doc.Clear;
  FBrowser.InitOutputRes;
  FBrowser.WriteHeader;
  //
  {
  if  (TabControl1.TabIndex = 0)  then  begin
    FBrowser.WriteRes(LinkItem.Res);
  end else begin
    if  (TabControl1.TabIndex = 2)  then  begin
      FBrowser.WriteRes(LinkItem.Res);
    end;
    sno   :=  IntToStr(LinkItem.Res.No);
    szno  :=  HanToZen(sno);
    for i :=  0 to  LinkItem.ResList.Count - 1  do  begin
      s :=  LinkItem.ResList[i].Body;
      if  (_IsRefNGRes('&gt;'  + sno, S))  or
          (_IsRefNGRes(''    + sno, S))  or
          (_IsRefNGRes('&gt;'  + szno, S))  or
          (_IsRefNGRes(''    + szno, S))  then
      begin
        FBrowser.WriteRes(LinkItem.ResList[i]);
      end;
    end;
  end;
  }
  //FBrowser.WriteRes(LinkItem.Res);
  {
  sno   :=  IntToStr(LinkItem.Res.No);
  szno  :=  HanToZen(sno);
  for i :=  0 to  LinkItem.ResList.Count - 1  do  begin
    s :=  LinkItem.ResList[i].Body;
    if  (_IsRefNGRes('&gt;'  + sno, S))  or
        (_IsRefNGRes(''    + sno, S))  or
        (_IsRefNGRes('&gt;'  + szno, S))  or
        (_IsRefNGRes(''    + szno, S))  then
    begin
      FBrowser.WriteRes(LinkItem.ResList[i]);
    end;
  end;
  }
  for i :=  0 to  ResList.Count - 1 do  begin
    ResList[i].Visible  :=  False;
  end;
  ExtractRes(LinkItem.ResList, LinkItem.Res.No, ResList);
  ResList[LinkItem.Res.No - 1].Visible  :=  True;
  for i :=  0 to  ResList.Count - 1 do  begin
    if  (ResList[i].Visible)  then  begin
      FBrowser.WriteRes(FBrowser.ResList[i]);
    end;
  end;

  FBrowser.EndOutputRes;
  doc.Close;
end;

procedure TExtractLinkDialog.FormActivate(Sender: TObject);
begin
  ShowList;
  FBrowser  :=  TZonuBrowser.Create(Self);
  TOleControl(FBrowser).Parent  :=  BrowserPanel;
  FBrowser.ResList        :=  TResList.Create(nil);
  //FBrowser.ThreadItem.Assign(ThreadItem);
  //FBrowser.Board        :=  ThreadItem.Board;
  FBrowser.Align          :=  alClient;
  //FBrowser.SkinPath       :=  ZonuConfig.SkinPath;
  //FBrowser.KatjushaSkin   :=  ZonuConfig.KatjushaSkin;
  FBrowser.InitSkin('', 'linkextract_dialog');
  FBrowser.Navigate('about:blank');
end;

procedure TExtractLinkDialog.CheckBox1Click(Sender: TObject);
begin
  ShowList;
  //CheckListBox1.OnClickCheck(CheckListBox1);
end;

procedure TExtractLinkDialog.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TExtractLinkDialog.ListView1Click(Sender: TObject);
var
  LinkItem  : TLinkItem;
begin
  if  (ListView1.Selected <> nil) then  begin
    if  (ListView1.Selected.Data  <> nil) then  begin
      LinkItem  :=  TLinkItem(ListView1.Selected.Data);
      Preview(LinkItem);
    end;
  end;
end;

procedure TExtractLinkDialog.Button3Click(Sender: TObject);
var
  s     : string;
  sl    : TStringList;
  li    : TLinkItem;
  i, x  : integer;
begin
  //摜t@C (*.jpg;*.jpeg;*.png;*.gif;*.bmp)|.jpg;.jpeg;.png;.gif;.bmp
  s   :=  ComboBox1.Items[ComboBox1.ItemIndex];
  s   :=  Copy(s, AnsiPos('|',s) + 1, Length(s));
  sl  :=  TStringList.Create;
  sl.CommaText  :=  StringReplace(s, ';', ',', [rfReplaceAll]);

  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    li  :=  TLinkItem(ListView1.Items[i].Data);
    for x :=  0 to  sl.Count - 1  do  begin
      if  (li.FileExt = sl[x])  then  begin
        ListView1.Items[i].Checked  :=  True;
        Break;
      end;
    end;
  end;

  sl.Free;
end;

procedure TExtractLinkDialog.CheckBox3Click(Sender: TObject);
begin
  ShowList;
  //CheckListBox1.OnClickCheck(CheckListBox1);
end;

procedure TExtractLinkDialog.FormShow(Sender: TObject);
begin
  WindowState :=  ZonuConfig.ExtractLinkWindowState;
  if  (WindowState = wsNormal)  then  begin
    Self.SetBounds( ZonuConfig.ExtractLinkPosLeft,
                    ZonuConfig.ExtractLinkPosTop,
                    ZonuConfig.ExtractLinkWidth,
                    ZonuConfig.ExtractLinkHeight);
  end;
end;

procedure TExtractLinkDialog.Button4Click(Sender: TObject);
var
  i: integer;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    ListView1.Items[i].Checked  :=  False;
  end;
end;

procedure TExtractLinkDialog.Button5Click(Sender: TObject);
var
  i: integer;
  li: TLinkItem;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    li  :=  TLinkItem(ListView1.Items[i].Data);
    if  (AnsiPos(Edit1.Text, li.Url) > 0) then  begin
      ListView1.Items[i].Checked  :=  True;
    end;
  end;
end;

procedure TExtractLinkDialog.A1Click(Sender: TObject);
var
  i: integer;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    ListView1.Items[i].Checked  :=  (Sender = A1);
  end;
end;

procedure TExtractLinkDialog.Button1Click(Sender: TObject);
var
  i : integer;
  s : string;
  LinkItem  : TLinkItem;
  dw: TDownloader;
begin
  if  (ComboBox2.ItemIndex > -1)  then  begin
    dw  :=  TDownloader(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
    if  (dw.Path = 'clipboard') then  begin
      s :=  '';
      for i :=  0 to  ListView1.Items.Count - 1 do  begin
        if  (ListView1.Items[i].Checked)  then  begin
          LinkItem  :=  TLinkItem(ListView1.Items[i].Data);
          if  (s <> '') then  s :=  s + #13#10;
          s :=  s + LinkItem.Url;
        end;
      end;
      ClipBoard.AsText  :=  S;
    end else begin
      s :=  '';
      for i :=  0 to  ListView1.Items.Count - 1 do  begin
        if  (ListView1.Items[i].Checked)  then  begin
          LinkItem  :=  TLinkItem(ListView1.Items[i].Data);
          if  (s <> '') then  s :=  s + #13#10;
          s :=  s + LinkItem.Url;
        end;
      end;
      ShellExecute(hInstance, 'open', PChar(dw.Path),
                   PChar(s), '', SW_SHOW);
    end;
  end;
end;


procedure TExtractLinkDialog.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  FBrowser.ThreadItem :=  nil;
  FBrowser.ResList    :=  nil;
  ZonuConfig.ExtractLinkWindowState :=  WindowState;
  if  (WindowState = wsNormal)  then  begin
    ZonuConfig.ExtractLinkPosLeft :=  Left;
    ZonuConfig.ExtractLinkPosTop  :=  Top;
    ZonuConfig.ExtractLinkWidth   :=  Width;
    ZonuConfig.ExtractLinkHeight  :=  Height;
  end;
end;

procedure TExtractLinkDialog.CheckBox2Click(Sender: TObject);
begin
  ShowList;
end;

procedure TExtractLinkDialog.AddThreadItem(AThreadItem: TThreadItem;
  AResList: TResList);
var
  XResList: TResList;
  XRes: TRes;
  i: integer;
begin
  XResList  :=  TResList.Create(AThreadItem);
  for i :=  0 to  AResList.Count - 1  do  begin
    XRes  :=  TRes.Create;
    XRes.Assign(AResList[i]);
    XRes.BBS  :=  AResList[i].BBS;
    XRes.Site :=  AResList[i].Site;
    XResList.Add(XRes);
  end;
  FList.Add(XResList);
end;

procedure TExtractLinkDialog.URLC1Click(Sender: TObject);
var
  i:  integer;
  s:  string;
begin
  s :=  '';
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    if  (ListView1.Items[i].Selected) then  begin
      if  (ListView1.Items[i].Data  <> nil) then  begin
        s :=  s + TLinkItem(ListView1.Items[i].Data).Url  + #13#10;
      end;
    end;
  end;
  Clipboard.AsText  :=  s;
end;

procedure TExtractLinkDialog.PageControl1Change(Sender: TObject);
var
  i : integer;
  doc : variant;
  LinkItem  : TLinkItem;
  sl : TStringList;
  s  : string;
begin
  if  (PageControl1.ActivePageIndex = 1)  then  begin
    WebBrowser2.Navigate('about:blank');
    while (not Assigned(WebBrowser2.Document)) do  begin
      Application.ProcessMessages;
      if  (ZonuEnviron.Disconnected)  then  begin
        raise EZonuError.Create('ؒf܂B');
      end;
    end;
    doc :=  WebBrowser2.Document;
    doc.Clear;
    doc.Write('<HTML><HEAD><META HTTP-EQUIV="Content-Type" CONTENT="text/html;CHARSET=x-sjis"></HEAD><BODY BGCOLOR="#ffffff">');
    sl  :=  TStringList.Create;
    if  (FileExists(ZonuConfig.UsersPath + FILE_LINKPRV)) then  begin
      sl.LoadFromFile(ZonuConfig.UsersPath + FILE_LINKPRV);
    end else begin
      sl.Add('<P><A HREF="%s">%s</A></P>');
      sl.SaveToFile(ZonuConfig.UsersPath + FILE_LINKPRV);
    end;
    S :=  sl.Text;
    sl.Free;
    for i :=  0 to  ListView1.Items.Count - 1 do  begin
      if  (ListView1.Items[i].Checked) then  begin
        LinkItem  :=  TLinkItem(ListView1.Items[i].Data);
        doc.Write(StringReplace(S, '%s', LinkItem.Url, [rfReplaceAll, rfIgnoreCase]));
      end;
    end;
    doc.Write('</body></html>');
    doc.Close;
  end;
end;

end.
