{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Handle Dialog Unit                                                }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Hndldlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ComCtrls, Main, ExtCtrls, Dlghead;

type
  THandleDialog = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Label6: TLabel;
    Label7: TLabel;
    ListView2: TListView;
    ComboBox1: TComboBox;
    Button1: TButton;
    ComboBox2: TComboBox;
    Label17: TLabel;
    Label18: TLabel;
    ComboBox5: TComboBox;
    ComboBox6: TComboBox;
    ListView1: TListView;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox3: TComboBox;
    Button2: TButton;
    ComboBox4: TComboBox;
    Edit1: TEdit;
    Label3: TLabel;
    Button3: TButton;
    Button4: TButton;
    HeaderFrame1: THeaderFrame;
    procedure ListView2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
    procedure BuildHandleList;
    procedure BuildThreadHandleList;
  public
    { Public 錾 }
  end;

var
  HandleDialog: THandleDialog;

implementation

{$R *.DFM}

uses
  ZonuClass, Hzbconst, ZonuConf, Zonutils, MonaUtils;

procedure THandleDialog.FormCreate(Sender: TObject);
var
  s : TStringList;
begin
  s :=  TStringList.Create;
  if  (FileExists(ZonuConfig.UsersPath + FILE_NAME_LOG))  then  begin
    s.LoadFromFile(ZonuConfig.UsersPath + FILE_NAME_LOG);
    ComboBox3.Items.AddStrings(s);
    ComboBox5.Items.AddStrings(s);
  end;
  if  (FileExists(ZonuConfig.UsersPath + FILE_MAIL_LOG))  then  begin
    s.LoadFromFile(ZonuConfig.UsersPath + FILE_MAIL_LOG);
    ComboBox4.Items.AddStrings(s);
    ComboBox6.Items.AddStrings(s);
  end;
  BuildHandleList;
  BuildThreadHandleList;
  ComboBox5.Text  :=  ZonuConfig.GlobalHandle;
  ComboBox6.Text  :=  ZonuConfig.GlobalMail;
  s.Free;
end;

procedure THandleDialog.ListView2Click(Sender: TObject);
begin
  if  (ListView2.Selected <> nil) then  begin
    //Board :=  TBoard(ListView2.Selected.Data);
    ComboBox1.Text  :=  ListView2.Selected.SubItems[1];
    ComboBox2.Text  :=  ListView2.Selected.SubItems[2];
  end;
end;

procedure THandleDialog.Button1Click(Sender: TObject);
//var
//  Board : TBoard;
begin
  if  (ListView2.Selected <> nil) then  begin
    //Board :=  TBoard(ListView2.Selected.Data);
    //*!*Board.HandleName  :=  ComboBox1.Text;
    //*!*Board.MailAddress :=  ComboBox2.Text;
    ListView2.Selected.SubItems[1]  :=  ComboBox1.Text;
    ListView2.Selected.SubItems[2]  :=  ComboBox2.Text;
  end;
end;

procedure THandleDialog.BuildHandleList;
var
  i : integer;
  HandleSetting : TStringList;

  //procedure BuildHandleList_(BBSName: string; BoardList: TBoardList);
  procedure BuildHandleList_(Site: TSite);
  var
    i : integer;
    NewItem : TListItem;
    HandleName, MailAddress: string;
  begin
    for i :=  0 to  Site.BoardList.Count - 1  do  begin
      NewItem :=  ListView2.Items.Add;
      NewItem.Caption :=  '[' + Site.SiteName + '] ' + Site.BoardList[i].CategoryName;
      NewItem.SubItems.Add(Site.BoardList[i].Name);
      HandleName  :=  HandleSetting.Values[Site.SiteID + '_' +
                                           Site.BoardList[i].BoardID + '_HANDLE'];
      MailAddress :=  HandleSetting.Values[Site.SiteID + '_' +
                                           Site.BoardList[i].BoardID + '_MAIL'];
      NewItem.SubItems.Add(HandleName);
      NewItem.SubItems.Add(MailAddress);
      NewItem.Data        :=  Site.BoardList[i];
      NewItem.ImageIndex  :=  Site.ImageIndex;
      if  (HandleName <> '')  then  begin
        if  (ComboBox1.Items.IndexOf(HandleName) < 0) then
        begin
          ComboBox1.Items.Add(HandleName);
          ComboBox3.Items.Add(HandleName);
        end;
      end;
      if  (MailAddress <> '')  then  begin
        if  (ComboBox2.Items.IndexOf(MailAddress) < 0) then
        begin
          ComboBox2.Items.Add(MailAddress);
          ComboBox4.Items.Add(MailAddress);
        end;
      end;
    end;
  end;
begin
  HandleSetting :=  TStringList.Create;
  if  (FileExists(ZonuConfig.UsersPath + FILE_HANDLE_SETTING)) then  begin
    HandleSetting.LoadFromFile(ZonuConfig.UsersPath + FILE_HANDLE_SETTING);
  end;
  for i :=  0 to  ZonuEnviron.SiteList.Count - 1 do  begin
    BuildHandleList_(ZonuEnviron.SiteList[i]);
  end;
  HandleSetting.Free;
end;



procedure THandleDialog.BitBtn1Click(Sender: TObject);
var
  Board : TBoard;
  th, hd : TStringList;
  i : integer;
begin
  th := TStringList.Create;
  hd := TStringList.Create;
  for i :=  0 to  ListView2.Items.Count - 1 do  begin
    Board :=  TBoard(ListView2.Items[i].Data);
    if  (ListView2.Items[i].SubItems[1] <> '')  then  begin
      hd.Add(Board.Site.SiteID + '_' +
             Board.BoardID + '_HANDLE=' +
             ListView2.Items[i].SubItems[1]);
    end;
    if  (ListView2.Items[i].SubItems[2] <> '')  then  begin
      hd.Add(Board.Site.SiteID + '_' +
             Board.BoardID + '_MAIL=' +
             ListView2.Items[i].SubItems[2]);
    end;
  end;
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    th.Add(ListView1.Items[i].Caption + #9 +
           ListView1.Items[i].SubItems[0] + #9 +
           ListView1.Items[i].SubItems[1]);
  end;
  hd.SaveToFile(ZonuConfig.UsersPath + FILE_HANDLE_SETTING);
  th.SaveToFile(ZonuConfig.UsersPath + FILE_THREAD_HANDLE);
  hd.Free;
  th.Free;
  ZonuConfig.GlobalHandle :=  ComboBox5.Text;
  ZonuConfig.GlobalMail   :=  ComboBox6.Text;
  ModalResult :=  mrOk;
end;

procedure THandleDialog.BuildThreadHandleList;
var
  Item : TListItem;
  th : TStringList;
  i : integer;
begin
  th := TStringList.Create;
  if  (FileExists(ZonuConfig.UsersPath + FILE_THREAD_HANDLE))  then  begin
    th.LoadFromFile(ZonuConfig.UsersPath + FILE_THREAD_HANDLE);
    for i :=  0 to  th.Count - 1  do  begin
      Item  :=  ListView1.Items.Add;
      Item.Caption  :=  ChooseString(th[i], #9, 0);
      Item.SubItems.Add(ChooseString(th[i], #9, 1));
      Item.SubItems.Add(ChooseString(th[i], #9, 2));
      if  (ComboBox3.Items.IndexOf(ChooseString(th[i], #9, 1)) < 0) then
      begin
        ComboBox3.Items.Add(ChooseString(th[i], #9, 1));
      end;
      if  (ComboBox4.Items.IndexOf(ChooseString(th[i], #9, 2)) < 0) then
      begin
        ComboBox4.Items.Add(ChooseString(th[i], #9, 2));
      end;
    end;
  end;
  th.Free;
end;

procedure THandleDialog.ListView1Click(Sender: TObject);
begin
  if  (ListView1.Selected <> nil) then  begin
    Edit1.Text      :=  ListView1.Selected.Caption;
    if  (ListView1.Selected.SubItems.Count > 0) then  begin
      ComboBox3.Text  :=  ListView1.Selected.SubItems[0];
      ComboBox4.Text  :=  ListView1.Selected.SubItems[1];
    end;
  end;
end;

procedure THandleDialog.Button4Click(Sender: TObject);
begin
  if  (ListView1.Selected <> nil) then  begin
    ListView1.Selected.Caption  :=  Edit1.Text;
    ListView1.Selected.SubItems.Clear;
    ListView1.Selected.SubItems.Add(ComboBox3.Text);
    ListView1.Selected.SubItems.Add(ComboBox4.Text);
  end;
end;

procedure THandleDialog.Button2Click(Sender: TObject);
var
  Item : TListItem;
begin
  Item  :=  ListView1.Items.Add;
  Item.Caption  :=  Edit1.Text;
  Item.SubItems.Clear;
  Item.SubItems.Add(ComboBox3.Text);
  Item.SubItems.Add(ComboBox4.Text);
end;

procedure THandleDialog.Button3Click(Sender: TObject);
begin
  if  (ListView1.Selected <> nil) then  begin
    ListView1.Selected.Delete;
  end;
end;

end.
