{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 ichigobbs Headline Unit                                           }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit IchigoHeadline;

interface

uses
  Classes, SysUtils, Contnrs, HttpProt,
  ZonuClass, ZonuHttp, ZonuCommon, Hzbconst;

type
  T15HeadlineBoard  = class(TObject)
  private
    FBoard: TBoard;
    FLastUpdate: string;
    FThreadCount: TStringList;
    FThreadDatNo: TStringList;
    FThreadTitle: TStringList;
  public
    constructor Create;
    destructor  Destroy; override;
    property  Board: TBoard   read  FBoard  write FBoard;
    property  LastUpdate: string  read  FLastUpdate write FLastUpdate;
    property  ThreadTitle: TStringList  read  FThreadTitle  write FThreadTitle;
    property  ThreadDatNo: TStringList  read  FThreadDatNo  write FThreadDatNo;
    property  ThreadCount: TStringList  read  FThreadCount  write FThreadCount;
  end;

  T15HeadlineLoader = class(TObject)
  private
    HttpCli1: THTTPCli;
    FHttpStream : TStringStream;
  public
    FBoardList: TObjectList;
    constructor Create;
    destructor  Destroy; override;
    procedure DownloadHeadline;
  end;
  
implementation

uses
  ZonuConf;

{ T15HeadlineBoard }

constructor T15HeadlineBoard.Create;
begin
  FThreadCount  :=  TStringList.Create;
  FThreadDatNo  :=  TStringList.Create;
  FThreadTitle  :=  TStringList.Create;
end;

destructor T15HeadlineBoard.Destroy;
begin
  FThreadCount.Free;
  FThreadDatNo.Free;
  FThreadTitle.Free;
  inherited;
end;

{ T15HeadlineLoader }

constructor T15HeadlineLoader.Create;
begin
  FBoardList  :=  TObjectList.Create;
end;

destructor T15HeadlineLoader.Destroy;
begin
  FBoardList.Free;
  inherited;
end;

procedure T15HeadlineLoader.DownloadHeadline;
var
  F15chSite: TSite;
  BoardID:  string;
  Board:  TBoard;
  hl: T15HeadlineBoard;
  sl: TStringList;
  i, n: integer;
  s: string;
begin
  HttpCli1      :=  THTTPCli.Create(nil);
  FHttpStream   :=  TStringStream.Create('');
  if  (ZonuConfig.ProxyUse) then  begin
    HttpCli1.Proxy          :=  ZonuConfig.Proxy;
    HttpCli1.ProxyPort      :=  ZonuConfig.ProxyPort;
    HttpCli1.ProxyUsername  :=  ZonuConfig.ProxyUserName;
    HttpCli1.ProxyPassword  :=  ZonuConfig.ProxyPassword;
  end;
  HttpCli1.Agent            :=  USER_AGENT;
  FHttpStream.Position      :=  0;
  FHttpStream.Size          :=  0;
  HttpCli1.RcvdStream       :=  FHttpStream;
  HttpCli1.URL              :=  ZonuConfig.IchigoHeadlineUrl;
  //
  HttpCli1.Get;
  //
  if  (HttpCli1.StatusCode = 200) then  begin
    ZonuEnviron.SiteList.FindSite('15ch', F15chSite);
    hl  :=  nil;
    sl  :=  TStringList.Create;
    sl.Text  :=  FHttpStream.DataString;
    for i :=  0 to  sl.Count - 1 do  begin
      if  (AnsiPos('<tbody>', sl[i]) > 0) then  begin
        s :=  Copy(sl[i], AnsiPos('<a href="../../', sl[i]) + 15, Length(sl[i]));
        s :=  Copy(s, 1, AnsiPos('/', s) - 1);
        BoardID :=  s;
        if  (F15chSite.BoardList.FindBoard(BoardID, Board)) then  begin
          hl  :=  T15HeadlineBoard.Create;
          hl.Board  :=  Board;
          FBoardList.Add(hl);
        end else begin
          Board :=  nil;
          hl    :=  nil;
        end;
      end else
      if  (AnsiPos('Last Update:', sl[i]) > 0) and (hl <> nil)  then begin
        s :=  Copy(sl[i], AnsiPos('Update:', sl[i]) + 7, Length(sl[i]));
        s :=  Copy(s, 1, AnsiPos('<', s) - 1);
        hl.LastUpdate :=  s;
      end else
      if  (AnsiPos('<a href=', sl[i]) = 1) and (hl <> nil) then  begin
        s :=  Copy(sl[i], AnsiPos('&vi=', sl[i]) + 4, Length(sl[i]));
        s :=  Copy(s, 1, AnsiPos('&', s) - 1);
        hl.ThreadDatNo.Add(s);

        s :=  Copy(sl[i], AnsiPos('</a>', sl[i]) + 4, Length(sl[i]));
        s :=  Copy(s, AnsiPos('>', s) + 1, Length(s));
        s :=  Copy(s, 1, AnsiPos('<', s) - 1);
        hl.ThreadTitle.Add(s);

        s :=  Copy(sl[i], AnsiPos('</a>(', sl[i]) + 5, Length(sl[i]));
        s :=  Copy(s, 1, AnsiPos(')', s) - 1);
        hl.ThreadCount.Add(s);

      end;
    end;

    if  (FBoardList.Count > 0)  then  begin
      for i :=  0 to  FBoardList.Count - 1  do  begin
        for n :=  0 to  FBoardList.Count - 2  do  begin
          if  (T15HeadlineBoard(FBoardList[n]).LastUpdate < T15HeadlineBoard(FBoardList[n + 1]).LastUpdate)  then
          begin
            FBoardList.Exchange(n, n + 1);
          end;
        end;
      end;
    end;
    
    sl.Free;
  end;
  HttpCli1.Free;
end;

end.
