{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Kill Popup Dialog Unit                                            }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Killpop;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Dlghead, StdCtrls, ExtCtrls, ComCtrls;

type
  TKillPopupDialog = class(TForm)
    HeaderFrame1: THeaderFrame;
    TabControl1: TTabControl;
    Panel1: TPanel;
    Button2: TButton;
    Button1: TButton;
    RichEdit1: TRichEdit;
    Button3: TButton;
    StatusBar1: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TabControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure TabControl1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure RichEdit1Change(Sender: TObject);
  private
    { Private 錾 }
    FKillTitle: TStringList;
    FKillURL: TStringList;
  public
    { Public 錾 }
  end;

var
  KillPopupDialog: TKillPopupDialog;

implementation

{$R *.dfm}

uses
  ZonuConf, ZonuClass, Hzbconst;

procedure TKillPopupDialog.FormCreate(Sender: TObject);
begin
  FKillTitle  :=  TStringList.Create;
  if  (FileExists(ZonuConfig.UsersPath + FILE_KILL_TITLE))  then  begin
    FKillTitle.LoadFromFile(ZonuConfig.UsersPath + FILE_KILL_TITLE);
  end;
  FKillUrl  :=  TStringList.Create;
  if  (FileExists(ZonuConfig.UsersPath + FILE_KILL_URL))  then  begin
    FKillUrl.LoadFromFile(ZonuConfig.UsersPath + FILE_KILL_URL);
  end;
  FKillUrl.Sort;
  RichEdit1.Lines.Assign(FKillURL);
end;

procedure TKillPopupDialog.FormDestroy(Sender: TObject);
begin
  FKillTitle.Free;
  FKillURL.Free;
end;

procedure TKillPopupDialog.TabControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  if  (TabControl1.TabIndex = 0)  then  begin
    FKillURL.Assign(RichEdit1.Lines);
  end else begin
    FKillTitle.Assign(RichEdit1.Lines);
  end;
end;

procedure TKillPopupDialog.TabControl1Change(Sender: TObject);
begin
  if  (TabControl1.TabIndex = 0)  then  begin
    FKillURL.Sort;
    RichEdit1.Lines.Assign(FKillURL);
  end else begin
    FKillTitle.Sort;
    RichEdit1.Lines.Assign(FKillTitle);
  end;
end;

procedure TKillPopupDialog.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TKillPopupDialog.Button1Click(Sender: TObject);
  procedure KillAboutBlank(var sl: TStringList);
  var
    i : integer;
  begin
    for i :=  sl.Count - 1  downto  0 do  begin
      if  (SameText(sl[i], 'about:blank'))  or
          (AnsiPos('about:blank', AnsiLowerCase(sl[i])) = 1)  then
      begin
        sl.Delete(i);
      end;
    end;
  end;
begin
  if  (TabControl1.TabIndex = 0)  then  begin
    FKillURL.Assign(RichEdit1.Lines);
  end else begin
    FKillTitle.Assign(RichEdit1.Lines);
  end;
  KillAboutBlank(FKillTitle);
  KillAboutBlank(FKillURL);
  FKillURL.SaveToFile(ZonuConfig.UsersPath + FILE_KILL_URL);
  FKillTitle.SaveToFile(ZonuConfig.UsersPath + FILE_KILL_TITLE);
  Close;
end;

procedure TKillPopupDialog.Button3Click(Sender: TObject);
var
  i, x: integer;
begin
  for i :=  0 to  RichEdit1.Lines.Count - 1 do  begin
    for x :=  RichEdit1.Lines.Count - 1   downto  i + 1 do  begin
      if  (RichEdit1.Lines[x] = RichEdit1.Lines[i]) or
          (Trim(RichEdit1.Lines[x]) = '')  then
      begin
        RichEdit1.Lines.Delete(x);
      end;
    end;
  end;
end;

procedure TKillPopupDialog.RichEdit1Change(Sender: TObject);
begin
  StatusBar1.Panels[0].Text :=  Format('%d', [RichEdit1.Lines.Count]);
end;

end.
