{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 megabbs Search Dialog Unit                                        }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit MegabbsSearch;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, IniFiles, HttpProt, ZonuClass;

type
  TMegabbsSearchDialog = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    KeyWord: TComboBox;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Image2: TImage;
    Bevel1: TBevel;
    Label5: TLabel;
    HttpCli1: THttpCli;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure Label5Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private 錾 }
    FHttpStream : TStringStream;
    FSite: TSite;
    FThreadItemList: TThreadItemList;
    FContent: string;
  public
    { Public 錾 }
    property ThreadItemList: TThreadItemList  read  FThreadItemList write FThreadItemList;
    property Content: string  read  FContent;
  end;

var
  MegabbsSearchDialog: TMegabbsSearchDialog;

implementation

{$R *.dfm}

uses
  ZonuConf, Hzbconst, Hzbfunc, Main, MonaUtils, HTTPApp;

procedure TMegabbsSearchDialog.FormCreate(Sender: TObject);
var
  i: integer;
begin
  if  (FileExists(ZonuConfig.UsersPath + FILE_FINDTEXT_LOG))  then  begin
    KeyWord.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_FINDTEXT_LOG);
  end;
  if  (ZonuEnviron.SiteList.FindSite('megabbs', FSite))  then  begin
    for i :=  0 to  FSite.BoardList.Count - 1  do  begin
      ListBox1.Items.AddObject(FSite.BoardList[i].Name, FSite.BoardList[i]);
    end;
  end;
  if  (ListBox1.Items.Count > 0) then  begin
    ListBox1.ItemIndex :=  0;
  end;
end;

procedure TMegabbsSearchDialog.Label5Click(Sender: TObject);
begin
  Open('http://www.megabbs.com/');
end;

procedure TMegabbsSearchDialog.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TMegabbsSearchDialog.BitBtn1Click(Sender: TObject);
var
  Board : TBoard;
  ini: TMemIniFile;
  s : string;
  ABoardID: string;
  ADatNo: string;
  ASubject: string;
  FBoard : TBoard;
  ThreadItem: TThreadItem;
  No, n : integer;
begin
  s :=  KeyWord.Text;
  if  (Trim(s) = '')  then  begin
    KeyWord.SetFocus;
    MessageDlg('L[[hĂB', mtError, [mbOk], 0);
    Exit;
  end;
  if  (s <> '') then  begin
    if  (KeyWord.Items.IndexOf(s) < 0) then  begin
      KeyWord.Items.Insert(0, s);
    end else begin
      KeyWord.Items.Move(KeyWord.Items.IndexOf(s), 0);
    end;
    KeyWord.Items.SaveToFile(ZonuConfig.UsersPath + FILE_FIND_LOG);
    if  (KeyWord.Items.IndexOf(s) < 0) then  begin
      KeyWord.Items.Insert(0, s);
    end else begin
      KeyWord.Items.Move(KeyWord.Items.IndexOf(s), 0);
    end;
    KeyWord.Items.SaveToFile(ZonuConfig.UsersPath + FILE_FINDTEXT_LOG);
    KeyWord.Text  :=  s;
  end;
  //
  //
  //
  Board :=  TBoard(ListBox1.Items.Objects[ListBox1.ItemIndex]);
  ini   :=  TMemIniFile.Create(FSite.ConfigPath + INI_SITE);
  S     :=  ini.ReadString('SEARCHCGI', ExtractHostName(Board.Url), '') +
            '?word='    + HTTPEncode(KeyWord.Text) +
            '&board='   + Board.BoardID +
            '&submit='  + HTTPEncode('');
  FHttpStream   :=  TStringStream.Create('');
  if  (ZonuConfig.ProxyUse) then  begin
    HttpCli1.Proxy          :=  ZonuConfig.Proxy;
    HttpCli1.ProxyPort      :=  ZonuConfig.ProxyPort;
    HttpCli1.ProxyUsername  :=  ZonuConfig.ProxyUserName;
    HttpCli1.ProxyPassword  :=  ZonuConfig.ProxyPassword;
  end;
  HttpCli1.Agent            :=  USER_AGENT;
  FHttpStream.Position      :=  0;
  FHttpStream.Size          :=  0;
  HttpCli1.RcvdStream       :=  FHttpStream;
  HttpCli1.URL              :=  S;
  HotzonuWindow.Memo1.Lines.Add('ł...');
  Screen.Cursor             :=  crHourGlass;
  KeyWord.Enabled           :=  False;
  ListBox1.Enabled         :=  False;
  BitBtn1.Enabled           :=  False;
  BitBtn2.Enabled           :=  False;
  HttpCli1.Get;
  if  (HttpCli1.StatusCode = 200) then  begin
    HotzonuWindow.Memo1.Lines.Add('emFEEE');
    FContent :=  FHttpStream.DataString;
    S   :=  Content;
    No  :=  0;
    while true  do  begin
      n :=  AnsiPos('<a href="', s);
      if  (n > 0) then  begin
        //<a href="http://www.megabbs.com/cgi-bin/readres.cgi?bo=hihanyoubou&vi=1015599858&res=23&fi=no" target="_blank">1</a>F  <b><a href="http://www.megabbs.com/cgi-bin/readres.cgi?bo=hihanyoubou&vi=1015599858&res=23&fi=no">ImegabbsKr͂IĂƎvĂl̐</a></b><br>
        S :=  Copy(S, n + 9, Length(S));
        //http://www.megabbs.com/cgi-bin/readres.cgi?bo=hihanyoubou&vi=1015599858&res=23&fi=no" target="_blank">1</a>F  <b><a href="http://www.megabbs.com/cgi-bin/readres.cgi?bo=hihanyoubou&vi=1015599858&res=23&fi=no">ImegabbsKr͂IĂƎvĂl̐</a></b><br>
        S :=  Copy(S, AnsiPos('readres.cgi?bo=', S) + 15, Length(s));
        ABoardID  :=  Copy(S, 1, AnsiPos('&', S) - 1);
        S :=  Copy(S, AnsiPos('&vi=', S) + 4, Length(s));
        ADatNo    :=  Copy(S, 1, AnsiPos('&', S) - 1);
        //&fi=no">ImegabbsKr͂IĂƎvĂl̐</a></b><br>
        S :=  Copy(S, AnsiPos('&fi=no">', S) + 8, Length(s));
        ASubject  :=  Copy(S, 1, AnsiPos('</a>', S) - 1);

        //AUrl      :=  StringReplace(Copy(S, 1, n - 1), '&amp;','&',[rfReplaceAll]);

        if  (FSite.BoardList.FindBoard(ABoardID, FBoard))  then  begin
          ThreadItem  :=  TThreadItem.Create;
          ThreadItem.CreateThreadItem(Board.Site.SiteID,
                                      Board.BoardID,
                                      ADatNo,
                                      ASubject);

          ThreadItem.LoadConfig;
          if  (ThreadItemList.FindThreadItem(ThreadItem.DatFileName) <> nil) then  begin
            ThreadItem.ReleaseRef;
          end else begin
            ThreadItem.No     :=  No;
            ThreadItemList.Add(ThreadItem);
            inc(No);
          end;
        end;
      end else begin
        Break;
      end;
    end;
  end else begin
    MessageDlg(IntToStr(HttpCli1.StatusCode) + #13#10 + HttpCli1.ReasonPhrase, mtError, [mbOk], 0);
  end;
  KeyWord.Enabled   :=  True;
  ListBox1.Enabled  :=  True;
  BitBtn1.Enabled   :=  True;
  BitBtn2.Enabled   :=  True;
  Screen.Cursor     :=  crDefault;
  ModalResult       :=  mrOk;
end;

end.
