{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Ninki net Ranking Unit                                            }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Ninkinet;

interface

uses
  Classes, SysUtils, ZonuClass, ZonuHttp, ZonuCommon, Hzbconst, HttpProt;

type
  TNinkinet = class(TThread)
  private
    FID: string;
    HttpCli1: THTTPCli;
  protected
    procedure Execute; override;
    procedure SetCookie(Sender: TObject; const Data: String; var Accept: Boolean);
  public
    constructor Create(const ID: string);
    destructor Destroy; override;
  end;

implementation

uses
  ZonuConf;

{ TNinkinet }

constructor TNinkinet.Create(const ID: string);
begin
  inherited Create(True);
  FreeOnTerminate :=  True;
  FID := ID;
  Resume;
end;

destructor TNinkinet.Destroy;
begin
  inherited;
end;

procedure TNinkinet.Execute;
var
  s: string;
begin
  inherited;
  if  (ZonuConfig.ExecNinkinet) then  begin
    HttpCli1      :=  THTTPCli.Create(nil);
    if  (ZonuConfig.ProxyUse) then  begin
      HttpCli1.Proxy          :=  ZonuConfig.Proxy;
      HttpCli1.ProxyPort      :=  ZonuConfig.ProxyPort;
      HttpCli1.ProxyUsername  :=  ZonuConfig.ProxyUserName;
      HttpCli1.ProxyPassword  :=  ZonuConfig.ProxyPassword;
    end;
    HttpCli1.Agent            :=  USER_AGENT;
    HttpCli1.URL              :=  StringReplace(ZonuConfig.NinkinetUrl, '<ID>', FID, [rfReplaceAll, rfIgnoreCase]);
    s :=  ZonuConfig.Fini.ReadString('NINKINET', FId, '');
    if  (s <> '') then  begin
      HttpCli1.Cookie :=  Format('%s=%s', [FId, s]);
    end;
    HttpCli1.OnCookie :=  SetCookie;
    HttpCli1.Get;
    HttpCli1.Abort;
    HttpCli1.Free;
  end;
end;

procedure TNinkinet.SetCookie(Sender: TObject; const Data: String;
  var Accept: Boolean);
var
  s: string;
begin
  if  (Data <> '') then  begin
    s :=  Copy(Data, AnsiPos(FId + '=', Data) + Length(FId) + 1, Length(Data));
    s :=  Copy(s, 1, AnsiPos(';', s) - 1);
    ZonuConfig.Fini.WriteString('NINKINET', FId, s);
    Accept  :=  True;
  end;
end;

end.
