{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Property Dialog Unit                                              }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Propdlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, ZonuClass, ZonuShortcutBar,
  Buttons;

type
  TPropertyWindow = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Button1: TButton;
    Button2: TButton;
    PageControl2: TPageControl;
    TabThreadItem: TTabSheet;
    Image1: TImage;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Bevel3: TBevel;
    Label12: TLabel;
    Label13: TLabel;
    Bevel4: TBevel;
    DatNo: TEdit;
    Path: TEdit;
    Size: TEdit;
    BBSName: TEdit;
    BoardName: TEdit;
    URL: TEdit;
    Title: TEdit;
    ResCount: TEdit;
    Priority: TEdit;
    LastReadDate: TEdit;
    LastSentDate: TEdit;
    ReadCount: TEdit;
    Memo: TMemo;
    DiskSize: TEdit;
    InFavorites: TCheckBox;
    KakoLog: TCheckBox;
    InShortcutBar: TCheckBox;
    TabBoard: TTabSheet;
    Image2: TImage;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Label14: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    RemoteBoardID: TEdit;
    BoardBBS: TEdit;
    BoardUrl: TEdit;
    TextBoardName: TEdit;
    Label15: TLabel;
    Label18: TLabel;
    BoardSize: TEdit;
    BoardPath: TEdit;
    Label19: TLabel;
    BoardValue: TEdit;
    Bevel7: TBevel;
    Label20: TLabel;
    CategoryName: TEdit;
    Label21: TLabel;
    CharSet: TEdit;
    SpeedButton1: TSpeedButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure KakoLogClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private 錾 }
    FThreadItem: TThreadItem;
  public
    { Public 錾 }
    procedure SetThreadItem(ThreadItem: TThreadItem);
    procedure SetBoard(Board: TBoard);
  end;

var
  PropertyWindow: TPropertyWindow;

implementation

{$R *.dfm}

uses
  Hzbfunc, Hzbclass, Favdlg, Hzbconst, shrdlg, ZonuConf;

{ TThreadPropertyWindow }

procedure TPropertyWindow.SetThreadItem(ThreadItem: TThreadItem);
var
  Rec: TSearchRec;
begin
  PageControl2.ActivePage   :=  TabThreadItem;
  FThreadItem           :=  ThreadItem;
  DatNo.Text            :=  ThreadItem.DatNo;
  Title.Text            :=  ThreadItem.Title;
  BBSName.Text          :=  ThreadItem.Site.SiteName;
  BoardName.Text        :=  ThreadItem.Board.Name;
  URL.Text              :=  ThreadItem.RemoteDatFileName;
  ResCount.Text         :=  IntToStr(ThreadItem.DownloadCount);
  Priority.Text         :=  IntToStr(ThreadItem.Priority);
  Memo.Lines.Text       :=  ThreadItem.Memo;
  LastReadDate.Text     :=  ThreadItem.LastLoadDate;
  LastSentDate.Text     :=  ThreadItem.LastSentDate;
  ReadCount.Text        :=  IntToStr(ThreadItem.LoadCount);
  Path.Text             :=  ThreadItem.LocalDatFileName;
  Size.Text             :=  Format('%d oCg (%d KB)', [ThreadItem.DatSize, ThreadItem.DatSize div 1024 + 1]);
  DiskSize.Text         :=  '';
  if  (ThreadItem.DatExists)  then  begin
    if  (FindFirst(ThreadItem.LocalDatFileName, faAnyFile, Rec) = 0) then  begin
      DiskSize.Text  := Format('%d oCg (%d KB)', [Rec.Size, Rec.Size div 1024 + 1]);
    end;
    FindClose(Rec);
  end;
  InFavorites.Checked   :=  ThreadItem.InFavorites;
  InShortcutBar.Checked :=  ThreadItem.InShortcut;
  KakoLog.Checked       :=  ThreadItem.IsKakoLog;
  InFavorites.Enabled   :=  (not ThreadItem.InLocalFolder);
end;

procedure TPropertyWindow.Button1Click(Sender: TObject);
begin
  //Cɓ
  if  (FThreadItem <> nil)  then  begin
    if  (FThreadItem.InFavorites) then  begin
      if  (not InFavorites.Checked) then  begin
        DeleteFromFav(FThreadItem);
        FThreadItem.InFavorites :=  False;
        FThreadItem.SaveConfig;
      end;
    end else begin
      if  (InFavorites.Checked) then  begin
        FavoriteDialog  :=  TFavoriteDialog.Create(Self);
        FavoriteDialog.TargetList.Add(FThreadItem);
        FavoriteDialog.IsThreadItem :=  True;
        if  (FavoriteDialog.ShowModal <> mrOk) then  begin
          InFavorites.Checked :=  False;
          Exit;
        end;
      end;
    end;

    //Cɓ
    if  (FThreadItem.InShortcut) then  begin
      if  (not InShortcutBar.Checked) then  begin
        DeleteFromShortcut(FThreadItem);
        FThreadItem.InShortcut :=  False;
        FThreadItem.SaveConfig;
      end;
    end else begin
      if  (InShortcutBar.Checked) then  begin
        ShortcutDialog  :=  TShortcutDialog.Create(Self);
        ShortcutDialog.AddTarget(otThread,
                                 FThreadItem.Title,
                                 FThreadItem.DatNo,
                                 FThreadItem.BoardID,
                                 FThreadItem.Site.SiteID);
        if (ShortcutDialog.ShowModal = mrOk) then begin
          FThreadItem.InShortcut  :=  True;
          FThreadItem.SaveConfig;
        end;
        ShortcutDialog.Release;
      end;
    end;

    //ߋO
    if  (FThreadItem.IsKakoLog <> KakoLog.Checked)  then  begin
      FThreadItem.IsKakoLog :=  KakoLog.Checked;
      FThreadItem.SaveConfig;
    end;

  end;
  //
  ModalResult :=  mrOk;
end;

procedure TPropertyWindow.Button2Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

procedure TPropertyWindow.SetBoard(Board: TBoard);
var
  Rec: TSearchRec;
  Size: real;
  Count: integer;
begin
  Size  :=  0;
  Count :=  0;
  PageControl2.ActivePage   :=  TabBoard;
  RemoteBoardID.Text        :=  Board.RemoteBoardID;
  TextBoardName.Text        :=  Board.Name;
  CategoryName.Text         :=  Board.CategoryName;
  BoardBBS.Text             :=  Board.Site.SiteName;
  BoardUrl.Text             :=  Board.Url;
  BoardPath.Text            :=  Board.CachePath;
  if  (Board.CharSet = csSJIS)  then  begin
    CharSet.Text  :=  'SJIS';
  end else begin
    CharSet.Text  :=  'EUC';
  end;
  if  (FindFirst(Board.CachePath + '*', faAnyFile, Rec) = 0) then  begin
    repeat
      if  (SameText(ExtractFileExt(Rec.Name), '.dat')) then  Inc(Count);
      Size  :=  Size  + Rec.Size;
    until (FindNext(Rec) <> 0);
  end;
  FindClose(Rec);
  if  (Size > (1024 * 1024))  then  begin
    BoardSize.Text            :=  Format('%n MB (%n oCg)',
                                        [Size / 1024 / 1024, Size]);
  end else begin
    BoardSize.Text            :=  Format('%n KB (%n oCg)',
                                        [Size / 1024, Size]);
  end;
  BoardValue.Text           :=  Format('DAT̐ : %d', [Count]);
end;

procedure TPropertyWindow.KakoLogClick(Sender: TObject);
begin
  if  (not ZonuConfig.Cached) then  begin
    MessageDlg('ۑ[hɂȂĂ܂B[t@C|ۑ[h]IɂĂB',
               mtWarning, [mbOk], 0);
    Exit;
  end;
end;

procedure TPropertyWindow.SpeedButton1Click(Sender: TObject);
begin
  FThreadItem.Color :=  clWindowText;
  FThreadItem.SaveConfig;
end;

end.
