{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Preview Window Unit                                               }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Prvw;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, OleCtrls, SHDocVw, ZonuClass, Hzbclass;

type
  TPreviewWindow = class(TForm)
    StatusBar1: TStatusBar;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    FOnClosePreview: TNotifyEvent;
    FResList: TResList;
    FOnEndPreview: TNotifyEvent;
  public
    { Public 錾 }
    FBrowser : TZonuBrowser;
    procedure SavePos;
    procedure ShowLocalRule(const FileName: string);
    property  OnClosePreview: TNotifyEvent  read  FOnClosePreview write FOnClosePreview;
    property  OnEndPreview: TNotifyEvent  read  FOnEndPreview write FOnEndPreview;
  end;

var
  PreviewWindow: TPreviewWindow;

implementation

{$R *.DFM}

uses
  ZonuConf, Hzbconst;

procedure TPreviewWindow.FormCreate(Sender: TObject);
begin
  FBrowser  :=  TZonuBrowser.Create(Self);
  TOleControl(FBrowser).Parent  :=  Self;
  FBrowser.Align  :=  alClient;
  FResList  :=  TResList.Create(nil);
  FBrowser.ResList  :=  FResList;
end;

procedure TPreviewWindow.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if  (Showing) then  begin
    SavePos;
  end;
  if  (Assigned(FOnClosePreview)) then  begin
    FOnClosePreview(Self);
  end;
end;

procedure TPreviewWindow.FormShow(Sender: TObject);
begin
  SetBounds(
    ZonuConfig.PreviewWindowPosLeft,
    ZonuConfig.PreviewWindowPosTop,
    ZonuConfig.PreviewWindowWidth,
    ZonuConfig.PreviewWindowHeight);
end;

procedure TPreviewWindow.SavePos;
begin
  if  (Showing) then  begin
    ZonuConfig.PreviewWindowPosLeft   :=  Left;
    ZonuConfig.PreviewWindowPosTop    :=  Top;
    ZonuConfig.PreviewWindowWidth     :=  Width;
    ZonuConfig.PreviewWindowHeight    :=  Height;
  end;
end;

procedure TPreviewWindow.FormDestroy(Sender: TObject);
begin
  //FResList.Free;
end;

procedure TPreviewWindow.ShowLocalRule(const FileName: string);
begin
  if  (FileExists(FileName))  then  begin
    FBrowser.Navigate(FileName);
  end;
end;

end.
