{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Shitaraba Messager Unit                                           }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit ShitarabaMail;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, Buttons, HttpProt;

type
  TShitarabaMailDialog = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Panel2: TPanel;
    Memo1: TMemo;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    SpeedButton1: TSpeedButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
  private
    { Private 錾 }
    FPassword: string;
    FToID: string;
    FSaveHeight: integer;
    function GetSendFrom: string;
    function GetSendTo: string;
    procedure SetSendFrom(const Value: string);
    procedure SetSendTo(const Value: string);
    function GetBody: string;
    procedure SetBody(const Value: string);
  public
    { Public 錾 }
    property  SendTo: string    read  GetSendTo write SetSendTo;
    property  SendFrom: string  read  GetSendFrom write SetSendFrom;
    property  Password: string  read  FPassword write FPassword;
    property  ToID: string    read  FToID write FToID;
    property  Body: string    read  GetBody write SetBody;
  end;

var
  ShitarabaMailDialog: TShitarabaMailDialog;

implementation

{$R *.dfm}

uses
  ZonuConf, MonaUtils, Hzbconst, jconvert;

{ TShitarabaMailDialog }

function TShitarabaMailDialog.GetSendFrom: string;
begin
  Result  :=  Edit2.Text;
end;

function TShitarabaMailDialog.GetSendTo: string;
begin
  Result  :=  Edit1.Text;
end;

procedure TShitarabaMailDialog.SetSendFrom(const Value: string);
begin
  Edit2.Text  :=  Value;
end;

procedure TShitarabaMailDialog.SetSendTo(const Value: string);
begin
  Edit1.Text  :=  Value;
end;

procedure TShitarabaMailDialog.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  Release;
end;

function TShitarabaMailDialog.GetBody: string;
begin
  Result  :=  Memo1.Lines.Text;
end;

procedure TShitarabaMailDialog.SetBody(const Value: string);
var
  i: integer;
begin
  Memo1.Lines.Text  :=  DecodeHTMLEsc(Value);
  for i :=  0 to  Memo1.Lines.Count - 1 do  begin
    Memo1.Lines[i]  :=  ZonuConfig.ResChar +  Memo1.Lines[i];
  end;
end;

procedure TShitarabaMailDialog.SpeedButton1Click(Sender: TObject);
var
  FHttpCli    : THttpCli;
  FPostStream : TStringStream;
  s: string;
begin
  Screen.Cursor :=  crHourGlass;
  s :=  Format('id=%s&from=%s&password=%s&message=%s&bbs=&type=send&submit=M',
               [FToID, '#' + FPassword, FPassword, Memo1.Lines.Text]);
  s :=  jconvert.sjis2euc(s);
  //
  FPostStream  :=  TStringStream.Create(s);
  FHttpCli                  :=  THttpCli.Create(nil);
  if  (ZonuConfig.ProxyUse) then  begin
    FHttpCli.Proxy          :=  ZonuConfig.Proxy;
    FHttpCli.ProxyPort      :=  ZonuConfig.ProxyPort;
    FHttpCli.ProxyUsername  :=  ZonuConfig.ProxyUserName;
    FHttpCli.ProxyPassword  :=  ZonuConfig.ProxyPassword;
  end;
  FHttpCli.Agent            :=  USER_AGENT;
  FHttpCli.SendStream       :=  FPostStream;
  FHttpCli.URL              :=  ZonuConfig.ShitarabaMsgUrl;
  FHttpCli.Reference        :=  'Referer: http://www.shitaraba.com/message.html';
  try
    try
      FHttpCli.Post;
    except
      //
    end;
  finally
    FHttpCli.Free;
    FPostStream.Free;
    Screen.Cursor :=  crDefault;
  end;
  Close;
end;

procedure TShitarabaMailDialog.FormActivate(Sender: TObject);
begin
  SetWindowPos(Handle,  HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  Height  :=  FSaveHeight;
end;

procedure TShitarabaMailDialog.FormCreate(Sender: TObject);
begin
  FSaveHeight :=  Height;
end;

procedure TShitarabaMailDialog.FormDeactivate(Sender: TObject);
begin
  FSaveHeight :=  Height;
  Height  :=  0;
end;

end.
