{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 BoardList Window Unit                                             }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit boardlst;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IniFiles, ZonuClass, ZonuHttp, Main, ComCtrls, Gikobas,
  HttpProt, ExtCtrls, Dlghead;

type
  PParamData  = ^TParamData;
  TParamData  = record
    Temp: string;
  end;

  TBoardListDialog = class(TForm)
    Label1: TLabel;
    ComboBox1: TComboBox;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Label3: TLabel;
    ComboBoxEx1: TComboBoxEx;
    Button3: TButton;
    ProgressBar1: TProgressBar;
    HeaderFrame1: THeaderFrame;
    Panel1: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox1: TCheckBox;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ComboBoxEx1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
    FParseBoardListSource: string;
    FGikoBas : TGikoBas;
    FZonuHttp : TZonuHttp;
    FStream : TStringStream;
    procedure Exec(Site: TSite; const Url: string);
    procedure BoardListDownloadError(Sender: TObject; Downloader: TDownloader;
      ErrorCode: integer; ErrorMsg: string);
    procedure DataBoardList(Sender: TObject; Downloader: TDownloader;
      Data: string; TotalSize, DownloadSize: integer; var MoreData: boolean);
    procedure EndBoardList(Sender: TObject; Downloader: TDownloader;
      Error: boolean);
    procedure ClearBoardGiko;
  public
    { Public 錾 }
  end;

var
  BoardListDialog: TBoardListDialog;

implementation

{$R *.dfm}

uses
  ZonuConf, Hzbconst, Hzbclass, Hzbfunc, ListActns;

procedure TBoardListDialog.FormCreate(Sender: TObject);
var
  i  : integer;
  Item  : TComboExItem;
begin
  FGikoBas  :=  TGikoBas.Create(Self);
  FStream   :=  TStringStream.Create('');
  if  (ZonuEnviron.SiteList.Count = 0) then  begin
    ComboBoxEx1.Enabled :=  False;
    ComboBox1.Enabled   :=  False;
    Button1.Enabled     :=  False;
  end else begin
    for i :=  0 to  ZonuEnviron.SiteList.Count - 1 do  begin
      if  (ZonuEnviron.SiteList[i].IsSubscription)  and
          (ZonuEnviron.SiteList[i].SiteType <> stUser) and
          (ZonuEnviron.SiteList[i].SiteType <> stLocal) and
          (ZonuEnviron.SiteList[i].SiteType <> stFavorites) then
      begin
        Item  :=  ComboBoxEx1.ItemsEx.Add;
        Item.Caption    :=  ZonuEnviron.SiteList[i].SiteName;
        Item.Data       :=  ZonuEnviron.SiteList[i];
        Item.ImageIndex :=  ZonuEnviron.SiteList[i].ImageIndex;
      end;
    end;
    if  (ComboBoxEx1.Items.Count > 0) then  begin
      ComboBoxEx1.ItemIndex :=  0;
      ComboBoxEx1.OnChange(ComboBoxEx1);
      Button1.Enabled :=  True;
    end else begin
      Button1.Enabled :=  False;
    end;
  end;
  if  (ZonuConfig.BoardListUpdateMode = 0)  then  begin
    RadioButton1.Checked  :=  True;
  end else begin
    RadioButton2.Checked  :=  True;
    CheckBox1.Checked     :=  ZonuConfig.BoardListAddNew;
    CheckBox2.Checked     :=  ZonuConfig.BoardListChange;
    CheckBox3.Checked     :=  ZonuConfig.BoardListDelete;
  end;
end;

procedure TBoardListDialog.FormDestroy(Sender: TObject);
begin
  //
  FGikoBas.Free;
  FStream.Free;
end;

procedure TBoardListDialog.ComboBoxEx1Change(Sender: TObject);
var
  ini   : TIniFile;
  Site  : TSite;
  Count : integer;
  i : integer;
begin
  Site  :=  TSite(ComboBoxEx1.ItemsEx[ComboBoxEx1.ItemIndex].Data);
  ini   :=  TIniFile.Create(Site.ConfigPath + INI_SITE);
  Count :=  ini.ReadInteger('BOARDLIST', 'COUNT', 0);
  ComboBox1.Clear;
  if  (Count > 0) then  begin
    for i :=  0 to  Count - 1 do  begin
      ComboBox1.Items.Add(ini.ReadString('BOARDLIST', 'BOARDLIST' + IntToStr(i + 1), ''));
    end;
    ComboBox1.ItemIndex :=  ini.ReadInteger('BOARDLIST', 'CURRENT', 0);
  end;
  Button1.Enabled :=  (FileExists(Site.ConfigPath + FILE_PARSE_BOARD));

  ini.Free;
end;

procedure TBoardListDialog.Button2Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

procedure TBoardListDialog.Button1Click(Sender: TObject);
var
  ini   : TIniFile;
  Site  : TSite;
  i : integer;
  s : string;
begin
  if  (ComboBox1.Text = '') then  begin
    Exit;
  end;
  if  (RadioButton1.Checked)  then  begin
    ZonuConfig.BoardListUpdateMode :=  0;
  end else begin
    ZonuConfig.BoardListUpdateMode :=  1;
    ZonuConfig.BoardListAddNew    :=  CheckBox1.Checked;
    ZonuConfig.BoardListChange    :=  CheckBox2.Checked;
    ZonuConfig.BoardListDelete    :=  CheckBox3.Checked;
  end;

  Button1.Enabled :=  False;
  Button2.Enabled :=  False;
  Button3.Enabled :=  True;
  Memo1.Lines.Clear;
  {
  if  (HotzonuForm.TabControl1.Tabs.Count > 0)  then  begin
    for i :=  HotzonuForm.TabControl1.Tabs.Count - 1  downto  0 do  begin
      HotzonuForm.CloseThreadList(i, False);
    end;
  end;
  if  (HotzonuForm.TabControl2.Tabs.Count > 0)  then  begin
    for i :=  HotzonuForm.TabControl2.Tabs.Count - 1  downto  0 do  begin
      HotzonuForm.CloseBrowser(i, False);
    end;
  end;
  }

  s :=  ComboBox1.Text;
  if  (Trim(s) <> '') then  begin
    if (ComboBox1.Items.IndexOf(ComboBox1.Text) < 0)  then  begin
      ComboBox1.Items.Insert(0, ComboBox1.Text);
    end;
    Site  :=  TSite(ComboBoxEx1.ItemsEx[ComboBoxEx1.ItemIndex].Data);
    ini   :=  TIniFile.Create(Site.ConfigPath + INI_SITE);
    ini.WriteInteger('BOARDLIST', 'COUNT', ComboBox1.Items.Count);
    for i :=  0 to  ComboBox1.Items.Count - 1 do  begin
      ini.WriteString('BOARDLIST', 'BOARDLIST' + IntToStr(i + 1), ComboBox1.Items[i]);
    end;
    ini.WriteInteger('BOARDLIST', 'CURRENT', ComboBox1.Items.IndexOf(s));
    ini.Free;
    //
    //
    //
    FParseBoardListSource :=  Site.ConfigPath + FILE_PARSE_BOARD;
    Exec(Site, s);
    //ModalResult :=  mrOk;
    Memo1.Lines.Add('Jn');
    Memo1.Lines.Add('-----------------------');
  end else begin
    Beep;
  end;
end;

procedure TBoardListDialog.ClearBoardGiko;
begin
  FGikoBas.AddVar('BoardName',    '');
  FGikoBas.AddVar('BoardURL',     '');
  FGikoBas.AddVar('BoardID',      '');
end;

procedure TBoardListDialog.Exec(Site: TSite; const Url: string);
var
  Downloader  : TBoardListDownloader;
  BoardList : TBoardList;
  pd: PParamData;
begin
  Memo1.Lines.Add('  MRBASIC\[Xt@C̓ǂݍ');
  Memo1.Lines.Add('  ' + FParseBoardListSource);
  Memo1.Lines.Add(' ');
  //BoardList :=  TBoardList.Create;
  FGikoBas.Source.LoadFromFile(FParseBoardListSource);

  pd  :=  New(PParamData);
  pd.Temp :=  '';

  Downloader            :=  TBoardListDownloader.Create;
  Downloader.Site       :=  Site;
  Downloader.BBS        :=  Site.BBS;
  Downloader.CharSet    :=  Site.CharSet;
  Downloader.ViewObject :=  nil;
  BoardList :=  TBoardList.Create;
  Downloader.Boardlist  :=  BoardList;

  {
  Downloader.OnData     :=  DataBoardList;
  Downloader.OnEnd      :=  EndBoardList;
  Downloader.OnError    :=  BoardListDownloadError;
  }
  Downloader.ParamData  :=  pd;

  FZonuHttp             :=  TZonuHttp.Create(Self);
  FZonuHttp.Downloader  :=  Downloader;
  FZonuHttp.Url         :=  Url;
  FZonuHttp.NoCache     :=  True;
  FZonuHttp.OnZonuData      :=  DataBoardList;
  FZonuHttp.OnZonuEnd       :=  EndBoardList;
  FZonuHttp.OnZonuError     :=  BoardListDownloadError;
  FZonuHttp.GetContent(Site.CachePath + 'boardlist.txt');

  Memo1.Lines.Add('  {[hꗗ̎擾Jn');
  Memo1.Lines.Add('  ' + Url);
  Memo1.Lines.Add(' ');
end;

//
//  {[hꗗ_E[h
//
procedure TBoardListDialog.DataBoardList(Sender: TObject;
  Downloader: TDownloader; Data: string;
  TotalSize, DownloadSize: integer; var MoreData: boolean);
var
  Board : TBoard;
  dl: TBoardListDownloader;
  pd: PParamData;
  S : string;
  n : integer;
begin
  ProgressBar1.Min      :=  0;
  ProgressBar1.Max      :=  TotalSize;
  ProgressBar1.Position :=  DownloadSize;

  dl  :=  TBoardListDownloader(Downloader);
  pd  :=  dl.ParamData;

  FGikoBas.AddVar('Data',       Data);
  FGikoBas.AddVar('ParseOk',    False);
  FGikoBas.AddVar('TempData',   pd.Temp);
  FGikoBas.AddVar('OK',         True);
  FGikoBas.exec;
  if  (FGikoBas.GetVar('ParseOk'))  then  begin
    Board :=  TBoard.Create;
    Board.Name              :=  FGikoBas.GetVar('BoardName');
    Board.Url               :=  FGikoBas.GetVar('BoardURL');
    Board.BoardID           :=  FGikoBas.GetVar('BoardID');
    Board.CategoryName      :=  FGikoBas.GetVar('CategoryName');
    Board.Site              :=  TSite(ComboBoxEx1.ItemsEx[ComboBoxEx1.ItemIndex].Data);
    Board.BBS               :=  Board.Site.BBS;
    S :=  Copy(Board.Url, 8, Length(Board.Url));
    n :=  Length(s) - Length(Board.BoardID) - 1;
    while true  do  begin
      //s = http://www.shitaraba.com/bbs/bbs/
      if  (Copy(S, n, Length(Board.BoardID) + 2) = '/' + Board.BoardID + '/') then  begin
        s :=  Copy(s, 1, n - 1);
        Break;
      end else begin
        Dec(n);
        if  (n < 1) then  Break;
      end;
    end;
    //S :=  Copy(S, 1, AnsiPos('/' + Board.BoardID + '/', S) - 1);
    Board.BoardPath         :=  S;
    ClearBoardGiko;
    //if  (Zonu.IsInclude(TSite(Adapter.SourceObject).IncludeUrl, Board.Url)) then  begin
    if  (dl.Site.IsInclude(Board.Url))  then  begin
      dl.BoardList.Add(Board);
    end else begin
      Board.Free;
    end;
  end;
  pd.Temp := FGikoBas.GetVar('TempData');
end;

procedure TBoardListDialog.EndBoardList(Sender: TObject; Downloader: TDownloader;
      Error: boolean);
var
  Site : TSite;
  BoardList : TBoardList;
  DelBoard  : TBoard;
  i, x : integer;
  b : boolean;
  CountNew, CountRename, CountMoved, CountDelete : integer;
  CategoryName : string;
  dl : TBoardListDownloader;
  pd : PParamData;
begin
  ProgressBar1.Min      :=  0;
  ProgressBar1.Max      :=  0;
  ProgressBar1.Position :=  0;

  dl := TBoardListDownloader(Downloader);
  BoardList :=  dl.BoardList;
  Site      :=  dl.Site;

  Memo1.Lines.Add('  {[hꗗ̎擾');
  Memo1.Lines.Add('  F' + IntToStr(BoardList.Count));
  Memo1.Lines.Add(' ');

  CountNew    :=  0;
  CountDelete :=  0;
  CountRename :=  0;
  CountMoved  :=  0;

  if  (BoardList.Count > 0) then  begin

    Memo1.Lines.Add('{[hꗗXVJn');
    //
    //  T
    //
    if  (RadioButton1.Checked)  or
        ((RadioButton2.Checked) and (CheckBox1.Checked))  then
    begin
      for i :=  0 to  BoardList.Count - 1 do  begin
        b :=  False;
        for x :=  0 to  Site.BoardList.Count - 1  do  begin
          if  (BoardList[i].BoardID =  Site.BoardList[x].BoardID) then  begin
            b :=  True;
            Break;
          end;
        end;
        if  (not b) then  begin
          Memo1.Lines.Add('ǉ܂B');
          Memo1.Lines.Add('@' + BoardList[i].Name);
          Memo1.Lines.Add('@' + BoardList[i].Url);
          Memo1.Lines.Add('');
          Inc(CountNew);
        end;
      end;
    end;
    //
    //  T
    //
    if  (RadioButton1.Checked)  or
        ((RadioButton2.Checked) and (CheckBox3.Checked))  then
    begin
      for x :=  0 to  Site.BoardList.Count - 1  do  begin
        b :=  False;
        for i :=  0 to  BoardList.Count - 1 do  begin
          if  (Site.BoardList[x].BoardID = BoardList[i].BoardID) then  begin
            b :=  True;
            Break;
          end;
        end;
        if  (not b) then  begin
          Memo1.Lines.Add('폜܂B');
          Memo1.Lines.Add('@' + Site.BoardList[x].Name);
          Memo1.Lines.Add('@' + Site.BoardList[x].Url);
          Memo1.Lines.Add('');
          Inc(CountDelete);
          //
          if  (Site.BoardList[x].Gaishutu)  then  begin
            DelBoard := TBoard.Create;
            DelBoard.Assign(Site.BoardList[x]);
            DelBoard.CategoryName :=  'deleted';
            BoardList.Add(DelBoard);
          end;
        end;
      end;
    end;
    //
    //  O̕ύX𒲂ׂ
    //
    if  (RadioButton1.Checked)  or
        ((RadioButton2.Checked) and (CheckBox2.Checked))  then
    begin
      for i :=  0 to  BoardList.Count - 1 do  begin
        for x :=  0 to  Site.BoardList.Count - 1  do  begin
          if  (BoardList[i].BoardID =  Site.BoardList[x].BoardID) then  begin
            if  (BoardList[i].Name <> Site.BoardList[x].Name) then  begin
              Memo1.Lines.Add('̖OύX܂B');
              Memo1.Lines.Add('@F' + Site.BoardList[x].Name);
              Memo1.Lines.Add('@VF' + BoardList[i].Name);
              Memo1.Lines.Add('');
              Inc(CountRename);
              UpdateFav(Site.BoardList[x].BoardPath,
                        Site.BoardList[x].BoardID,
                        BoardList[i].BoardPath,
                        BoardList[i].Name,
                        BoardList[i]);
            end;
            Break;
          end;
        end;
      end;
      //
      //  URL̕ύX𒲂ׂ
      //
      for i :=  0 to  BoardList.Count - 1 do  begin
        for x :=  0 to  Site.BoardList.Count - 1  do  begin
          if  (BoardList[i].BoardID =  Site.BoardList[x].BoardID) then  begin
            if  (BoardList[i].Url <> Site.BoardList[x].Url) then  begin
              Memo1.Lines.Add('URLύX܂B');
              Memo1.Lines.Add('@' + Site.BoardList[x].Name);
              Memo1.Lines.Add('@F' + Site.BoardList[x].Url);
              Memo1.Lines.Add('@VF' + BoardList[i].Url);
              Memo1.Lines.Add('');
              Inc(CountMoved);
              UpdateFav(Site.BoardList[x].BoardPath,
                        Site.BoardList[x].BoardID,
                        BoardList[i].BoardPath,
                        BoardList[i].Name,
                        BoardList[i]);
            end;
            Break;
          end;
        end;
      end;
    end;
    
    if  (CountNew > 0) or (CountRename > 0) or (CountDelete > 0) or (CountMoved > 0) then
    begin
      //
      //  {[hꗗt@C̃obNAbv
      //
      DeleteFile(ChangeFileExt(Site.ConfigPath + FILE_BOARD, '.bak'));
      CopyFile(PChar(Site.ConfigPath + FILE_BOARD),
               PChar(ChangeFileExt(Site.ConfigPath + FILE_BOARD, '.bak')),
               True);
      //
      //  {[hꗗt@C
      //
      CategoryName  :=  '';
      BoardList.Site  :=  Site;
      BoardList.SaveToFile(ZonuConfig.UsersPath + 'config\site\' + Site.SiteID + '\' + FILE_BOARD);
      //BoardList.SaveToFile(Site.ConfigPath + FILE_BOARD);
      //
      Site.BoardList.Clear;
      Site.LoadBoardList;
      if  (HotzonuWindow.ActiveSite = Site) then  begin
        BuildBoardList(HotzonuWindow.BoardListView, Site);
      end;
      {
      for i :=  0 to  HotzonuMainWindow.BBSNode.Count - 1 do  begin
        if  (TSite(HotzonuForm.BBSNode.Item[i].Data) = Site)  then  begin
          HotzonuForm.BBSNode.Item[i].DeleteChildren;
          Site.BoardList.Clear;
          Site.LoadBoardList;
          BuildBoardList(HotzonuForm.BBSNode.Item[i]);
          ReleaseFavorites(HotzonuForm.TreeView2);
          HotzonuForm.TreeView2.Items.Clear;
          BuildFavorites(HotzonuForm.TreeView2);
        end;
      end;
      }
    end;

  end else begin
    Memo1.Lines.Add('  {[hꗗ̎擾G[(ЂƂ)');
  end;

  Memo1.Lines.Add('-----------------------');
  Memo1.Lines.Add('I');
  Memo1.Lines.Add('VK@F' + IntToStr(CountNew));
  Memo1.Lines.Add('ړ]@F' + IntToStr(CountMoved));
  Memo1.Lines.Add('폜@F' + IntToStr(CountDelete));
  Memo1.Lines.Add('OύXF' + IntToStr(CountRename));

  Boardlist.Free;
  pd  :=  dl.ParamData;
  Dispose(pd);
  dl.Free;


  Button1.Enabled :=  True;
  Button2.Enabled :=  True;
  Button3.Enabled :=  False;
end;

procedure TBoardListDialog.Button3Click(Sender: TObject);
begin
  FZonuHttp.Abort;
end;

procedure TBoardListDialog.BoardListDownloadError(Sender: TObject;
  Downloader: TDownloader;  ErrorCode: integer; ErrorMsg: string);
var
  dl  : TBoardListDownloader;
begin
  ProgressBar1.Min      :=  0;
  ProgressBar1.Max      :=  0;
  ProgressBar1.Position :=  0;
  if  (ErrorCode <> 0)  then  begin
    dl  :=  TBoardListDownloader(Downloader);
    Memo1.Lines.Add('{[hꗗ擾G[');
    Memo1.Lines.Add('@' +  dl.Site.SiteName);
    Memo1.Lines.Add(IntToStr(ErrorCode) + ':' + ErrorMsg);
    Memo1.Lines.Add('');
    Button1.Enabled :=  True;
    Button2.Enabled :=  True;
    Button3.Enabled :=  False;
  end;
end;



end.
