{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Shortcut Window Unit                                              }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit shrdlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, ZonuClass, Menus, ZonuShortcutBar,
  Dlghead;

type
  PTargetData = ^TTargetData;
  TTargetData = record
    TargetType  : TObjectType;
    Title       : string;
    Param1      : string;
    Param2      : string;
    Param3      : string;
  end;

  TShortcutDialog = class(TForm)
    ListBox1: TListBox;
    Image1: TImage;
    Label1: TLabel;
    Button3: TButton;
    Button1: TButton;
    Button2: TButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Edit1: TEdit;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    D1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    Rename1: TMenuItem;
    HeaderFrame1: THeaderFrame;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure D1Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure Rename1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FList: TList;
    { Private 錾 }
    //FTarget: TObject;
    {
    FTargetType: TObjectType;
    FParam1: string;
    FTitle: string;
    FParam2: string;
    FParam3: string;
    procedure SetTitle(const Value: string);
    }
  public
    { Public 錾 }
    //property  Target: TObject  read  FTarget  write FTarget;
    {
    property  TargetType: TObjectType read  FTargetType write FTargetType;
    property  Title: string   read  FTitle  write SetTitle;
    property  Param1: string  read  FParam1 write FParam1;
    property  Param2: string  read  FParam2 write FParam2;
    property  Param3: string  read  FParam3 write FParam3;
    }
    property  List: TList read  FList write FList;
    procedure AddTarget(TargetType: TObjectType; Title, Param1, Param2, Param3: string);
  end;

var
  ShortcutDialog: TShortcutDialog;

implementation

{$R *.dfm}

uses
  Hzbclass, Hzbconst, Hzbfunc;

procedure TShortcutDialog.FormCreate(Sender: TObject);
begin
  FList :=  TList.Create;
  BuildShortcutList(ListBox1);
end;

procedure TShortcutDialog.ListBox1DrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  DrawTabDataListBox(ListBox1, Index, Rect, State);
end;

procedure TShortcutDialog.Button1Click(Sender: TObject);
var
  TargetData  : PTargetData;
  sd : TShortcutData;
  td : TTabData;
  i : integer;
begin
  if  (ListBox1.ItemIndex > -1) then  begin
    td  :=  TTabData(ListBox1.Items.Objects[ListBox1.ItemIndex]);
    for i :=  FList.Count - 1 downto  0 do  begin
      TargetData  :=  PTargetData(FList[i]);
      if  (SpeedButton1.Down) then  begin
        sd  :=  td.Insert(0)
      end else begin
        sd  :=  td.Add;
      end;
      if  (FList.Count > 1) then  begin
        sd.Title    :=  TargetData.Title;
      end else begin
        sd.Title    :=  Edit1.Text;
      end;
      sd.Param1       :=  TargetData.Param1;
      sd.Param2       :=  TargetData.Param2;
      sd.Param3       :=  TargetData.Param3;
      sd.ObjectType   :=  TargetData.TargetType;
    end;
    SaveShortcutList(ListBox1);
    ReleaseShortcutList(ListBox1);
    ModalResult :=  mrOk;
  end else begin
    Beep;
  end;
end;

procedure TShortcutDialog.Button2Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

procedure TShortcutDialog.Button3Click(Sender: TObject);
var
  s : string;
  td: TTabData;
begin
  s :=  'V^u';
  while true  do  begin
    if  (InputQuery('^u', '^u̖O', s)) then  begin
      if  (ListBox1.Items.IndexOf(s) > -1)  then  begin
        MessageDlg('łɓ̃^u݂܂B', mtError, [mbOk], 0);
      end else
      if  (s = '')  then  begin
        MessageDlg('O͂ĂB', mtError, [mbOk], 0);
      end else begin
        td  :=  TTabData.Create;
        td.Title  :=  s;
        td.Color  :=  clBtnFace;
        td.BitmapFileName :=  'images\folder.bmp';
        ListBox1.Items.Objects[ListBox1.Items.Add(s)] :=  td;
        Break;
      end;
    end else begin
      Break;
    end;
  end;
end;

procedure TShortcutDialog.D1Click(Sender: TObject);
var
  td : TTabData;
begin
  if  (ListBox1.ItemIndex > -1) then  begin
    td  :=  TTabData(ListBox1.Items.Objects[ListBox1.ItemIndex]);
    td.Free;
    ListBox1.Items.Delete(ListBox1.ItemIndex);
  end else begin
    Beep;
  end;
end;

procedure TShortcutDialog.N3Click(Sender: TObject);
var
  n : integer;
begin
  if  (ListBox1.ItemIndex > 0) then  begin
    n :=  ListBox1.ItemIndex;
    ListBox1.Items.Move(n, n - 1);
    ListBox1.ItemIndex  :=  n - 1;
    ListBox1.SetFocus;
  end else begin
    Beep;
  end;
end;

procedure TShortcutDialog.N4Click(Sender: TObject);
var
  n : integer;
begin
  if  (ListBox1.ItemIndex < ListBox1.Items.Count - 1) then  begin
    n :=  ListBox1.ItemIndex;
    ListBox1.Items.Move(n, n + 1);
    ListBox1.ItemIndex  :=  n + 1;
    ListBox1.SetFocus;
  end else begin
    Beep;
  end;
end;

procedure TShortcutDialog.Rename1Click(Sender: TObject);
var
  s : string;
  td: TTabData;
begin
  if  (ListBox1.ItemIndex > -1) then  begin
    td  :=  TTabData(ListBox1.Items.Objects[ListBox1.ItemIndex]);
    s   :=  td.Title;
    ListBox1.Items[ListBox1.ItemIndex]  :=  '@';
    while true  do  begin
      if  (InputQuery('^u', '^u̖O', s)) then  begin
        if  (ListBox1.Items.IndexOf(s) > -1)  then  begin
          MessageDlg('łɓ̃^u݂܂B', mtError, [mbOk], 0);
        end else begin
          td.Title  :=  s;
          Break;
        end;
      end else begin
        Break;
      end;
    end;
    ListBox1.Items[ListBox1.ItemIndex]  :=  td.Title;
  end;
end;

procedure TShortcutDialog.AddTarget(TargetType: TObjectType; Title, Param1,
  Param2, Param3: string);
var
  TargetData: PTargetData;
begin
  New(TargetData);
  TargetData.TargetType   :=  TargetType;
  TargetData.Title        :=  Title;
  TargetData.Param1       :=  Param1;
  TargetData.Param2       :=  Param2;
  TargetData.Param3       :=  Param3;
  FList.Add(TargetData);
end;

procedure TShortcutDialog.FormShow(Sender: TObject);
begin
  if  (FList.Count > 0) then  begin
    Edit1.Text  :=  PTargetData(FList[0]).Title;
    if  (FList.Count > 1) then  begin
      Edit1.Text  :=  Edit1.Text;
    end;
  end else begin
    Edit1.Text  :=  '';
  end;
end;

procedure TShortcutDialog.FormDestroy(Sender: TObject);
var
  i : integer;
begin
  for i :=  FList.Count - 1 downto  0 do  begin
    Dispose(FList[i]);
  end;
  FList.Free;
end;

end.
